<TeXmacs|1.99.2>

<style|<tuple|beamer|mathemagix|ice|vdh|pari|caas>>

<\body>
  <screens|<\shown>
    \;

    <\with|par-mode|center>
      <strong|<\with|font-base-size|15>
        Fast integer multiplication
      </with>>

      David Harvey, <strong|Joris van der Hoeven>, Grgoire Lecerf

      <small|CNRS, cole polytechnique>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<image|texmacs-chip.ps|0.6w|0.6h||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<strong|Bordeaux,
      February 2, 2015<rsub|<math|<rsub|>>>>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|brown|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|dark
      green|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>|<anim-constant|<with|color|dark
      green|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>>>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Fundamental complexities>

    <unroll|<\shown>
      <math|<math-ss|I><around*|(|n|)>>: multiplication of two <math|n>-digit
      integers

      <math|<math-ss|M><rsub|\<bbb-K\>><around*|(|n|)>>: multiplication of
      two polynomials in <math|\<bbb-K\><around*|[|x|]>> of degree
      <math|\<less\>n>

      <math|r<rsup|\<omega\>>>: multiplication of two <math|r\<times\>r>
      matrices

      \;
    </shown>|<\hidden*>
      <strong|More involved operations>

      <tabular|<tformat|<table|<row|<cell|Division in
      <math|\<bbb-Z\>>>|<cell|>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>|)>>>>|<row|<cell|GCD
      in <math|\<bbb-Z\>>>|<cell|>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
      n|)>>>>|<row|<cell|Division in <math|\<bbb-K\><around*|[|X|]>>>|<cell|>|<cell|<math|O<around*|(|<math-ss|M><rsub|\<bbb-K\>><around*|(|n|)>|)>>>>|<row|<cell|GCD
      in <math|\<bbb-K\><around*|[|X|]>>>|<cell|>|<cell|<math|O<around*|(|<math-ss|M><rsub|\<bbb-K\>><around*|(|n|)>*log
      n|)>>>>|<row|<cell|Inverting an <math|r\<times\>r>
      matrix>|<cell|>|<cell|<math|O<around*|(|r<rsup|\<omega\>>|)>>>>|<row|<cell|Multiplication
      of <math|r\<times\>r> integer matrices
      (<math|n\<gg\>r>)>|<cell|>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*r<rsup|2>|)>>>>|<row|<cell|Multiplication
      of <math|r\<times\>r> integer matrices
      (<math|r\<gg\>n>)>|<cell|>|<cell|<math|O<around*|(|n*r<rsup|\<omega\>>|)>>>>|<row|<cell|Roots
      of polynomial in <math|\<bbb-C\><around*|[|X|]>>, precision
      <math|p\<ggg\>n>>|<cell|>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n*p|)>*log
      n|)>>>>|<row|<cell|Exponentiation with <math|n>-bit
      precision>|<cell|>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
      n|)>>>>|<row|<cell|Stokes matrix of holonomic function over
      <math|<smash|<wide|\<bbb-Q\>|^>>>>|<cell|>|<cell|<math|O<around*|(|r<rsup|2>*<math-ss|I><around*|(|n|)>*log<rsup|3>
      n|)>>>>|<row|<cell|Etc.>|<cell|>|<cell|>>>>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Computational models>

    <unroll|<\shown>
      <\compact>
        <strong|Sequential <em|<abbr|vs.>> parallel>

        We will consider sequential algorithms

        \;
      </compact>
    </shown>|<\hidden*>
      <strong|Turing machines>

      Turing machines with a finite number of tapes [Papadimitriou 94]

      \;
    </hidden*>|<\hidden*>
      <strong|Other bit complexity models>

      <\compact>
        <\itemize>
          <item>Operations on <math|log n>-bit numbers in time
          <math|O<around*|(|1|)>>

          <item>Random access machine (RAM)
        </itemize>
      </compact>

      \;
    </hidden*>|<\hidden*>
      <strong|\S Straight Line Programs \T (SLPs)>

      DAGs, non branching programs [Brgisser--Clausen--Shokrollahi 97]

      \;
    </hidden*>|<\hidden*>
      <strong|Other algebraic complexity models>

      <\compact>
        <\itemize>
          <item>Turing machines with entries in model-theoretic structures
          <math|\<frak-S\>> [Friedman 69]

          <item>BSS machines [Blum--Shub--Smale 89]
        </itemize>
      </compact>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Integer multiplication, very short history>

    \;

    \;

    <htab|5mm><block|<tformat|<cwith|1|-1|1|-1|cell-tsep|0.5spc>|<cwith|1|-1|1|-1|cell-bsep|0.5spc>|<cwith|6|6|1|3|cell-tsep|0.5spc>|<cwith|6|6|1|3|cell-bsep|0.5spc>|<cwith|1|1|1|-1|cell-background|<pattern|/Users/vdhoeven/texmacs/src/TeXmacs/misc/patterns/ice-dark-blue.png||>>|<table|<row|<cell|<with|color|white|Date>>|<cell|<with|color|white|Authors>>|<cell|<with|color|white|Complexity>>>|<row|<cell|<math|\<less\>>3000
    aJC>|<cell|Unknown>|<cell|<math|O<around*|(|n<rsup|2>|)>>>>|<row|<cell|1962>|<cell|Karatsuba>|<cell|<math|O<around|(|n<rsup|log
    3/log 2>|)>>>>|<row|<cell|1963 <greyed|(1965)>>|<cell|Toom
    <greyed|(Cook)>>|<cell|<math|O<around|(|<with|font-shape|italic|n*>2<rsup|5*<sqrt|log
    n/log 2>>|)>>>>|<row|<cell|1966>|<cell|Schnhage>|<cell|<math|O<around|(|n*2<rsup|<sqrt|2*log
    n/log 2>>*<around*|(|log n|)><rsup|3/2>|)>>>>|<row|<cell|1969>|<cell|Knuth>|<cell|<math|O<around|(|n*2<rsup|<sqrt|2*log
    n/log 2>>*log n|)>>>>|<row|<cell|1971>|<cell|Schnhage--Strassen>|<cell|<math|O<around*|(|n*log
    n*log log n|)>>>>|<row|<cell|2007>|<cell|Frer>|<cell|<math|O<around*|(|n*log
    n*2<rsup|O<around*|(|log<rsup|\<ast\>>
    n|)>>|)>>>>|<row|<cell|2014>|<cell|Harvey--vdH--Lecerf>|<cell|<math|O<around*|(|n*log
    n*8<rsup|log<rsup|\<ast\>> n>|)>>>>>>><htab|5mm>

    \;

    <\eqnarray*>
      <tformat|<table|<row|<cell|log<rsup|\<ast\>>
      x>|<cell|\<assign\>>|<cell|min <around*|{|k\<in\>\<bbb-N\>:log<rsup|\<circ\>k>
      x\<leqslant\>1|}>,<label|it-log>>>|<row|<cell|<op|log<rsup|\<circ\>k>>>|<cell|\<assign\>>|<cell|<op|log>\<circ\><below|\<cdots\>|k\<times\>>\<circ\><op|log>.>>>>
    </eqnarray*>
  </hidden>|<\hidden>
    <tit|Multiplication by evaluation-interpolation>

    <unroll|<\shown>
      <strong|Kronecker>

      <\eqnarray*>
        <tformat|<table|<row|<cell|971362<with|color|dark
        green|651726>262537<with|color|dark
        green|182735>>|<cell|=>|<cell|971362*X<rsup|3>+<with|color|dark
        green|651726>*X<rsup|2>+262537*X+<with|color|dark
        green|182735>>>|<row|<cell|X>|<cell|=>|<cell|1000000>>>>
      </eqnarray*>

      \;
    </shown>|<\hidden*>
      <strong|Evaluation-interpolation>

      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1cm|<tuple|0.430004gw|0.499999gh>>|gr-geometry|<tuple|geometry|1par|0.317374par|center>|gr-transformation|<tuple|<tuple|1.0|0.0|0.0|0.0>|<tuple|0.0|-0.987479769908862|-0.157745694143246|0.0>|<tuple|0.0|0.157745694143246|-0.987479769908862|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-arrow-end|\<gtr\>|gr-dash-style|11100|gr-text-at-halign|center|<graphics||<with|text-at-valign|center|text-at-halign|center|<math-at|P<around*|(|x<rsub|0>|)>,\<ldots\>,P<around*|(|x<rsub|N-1>|)>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|Q<around*|(|x<rsub|0>|)>,\<ldots\>,Q<around*|(|x<rsub|N-1>|)>|<point|-2|-2>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|P*Q|<point|5.5|2.0>>>|<with|arrow-end|\<gtr\>|<line|<point|-2.0|1.5>|<point|-2.00937624024342|-0.712792697446752>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|P,Q\<in\>\<bbb-K\><around*|[|X|]>|<point|-2.0|2.0>>>|<with|arrow-end|\<gtr\>|<line|<point|0.294284958327821|-1.50029765842043>|<point|2.26891784627596|-1.5>>>|<with|arrow-end|\<gtr\>|<line|<point|5.5|-0.75>|<point|5.5|1.53695925386956>>>|<with|arrow-end|\<gtr\>|dash-style|11100|<line|<point|0.25|2>|<point|4.82064426511443|2.0>>>|<with|text-at-valign|center|text-at-halign|right|<text-at|Evaluation|<point|-2.5|0.5>>>|<with|text-at-valign|center|<text-at|Interpolation|<point|6|0.5>>>|<with|text-at-halign|center|<text-at|Multiplication|<point|2.5|2.5>>>|<with|text-at-halign|center|<text-at|Point-wise
      multiplication|<point|1.5|-3>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|<around*|(|P*Q|)><around*|(|x<rsub|0>|)>,\<ldots\>,<around*|(|P*Q|)><around*|(|x<rsub|N-1>|)>|<point|5.8024209551528|-1.47479825373727>>>>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Example: Karatsuba multiplication>

    <\equation*>
      <tabular*|<tformat|<table|<row|<cell|p=127622<with|color|dark
      green|142187>>|<cell|>|<cell|q=209836<with|color|dark
      green|129877>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|P=127622*X+<with|color|dark
      green|142187>>|<cell|>|<cell|Q=209836*X+<with|color|dark
      green|129877>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|<tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|r>|<cwith|1|-1|3|3|cell-halign|l>|<table|<row|<cell|P<around*|(|\<infty\>|)>>|<cell|=>|<cell|127622*\<infty\>>>|<row|<cell|P<around*|(|0|)>>|<cell|=>|<cell|<with|color|dark
      green|142187>>>|<row|<cell|P<around*|(|1|)>>|<cell|=>|<cell|<with|color|dark
      red|269809>>>>>>>|<cell|>|<cell|<tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|r>|<cwith|1|-1|3|3|cell-halign|l>|<table|<row|<cell|Q<around*|(|\<infty\>|)>>|<cell|=>|<cell|209836*\<infty\>>>|<row|<cell|Q<around*|(|0|)>>|<cell|=>|<cell|<with|color|dark
      green|129877>>>|<row|<cell|Q<around*|(|1|)>>|<cell|=>|<cell|<with|color|dark
      red|339713>>>>>>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<tabular*|<tformat|<cwith|1|-1|1|1|cell-halign|r>|<cwith|1|-1|3|3|cell-halign|l>|<table|<row|<cell|<around*|(|P*Q|)><around*|(|\<infty\>|)>>|<cell|=>|<cell|26779689992*\<infty\><rsup|2>>>|<row|<cell|<around*|(|P*Q|)><around*|(|0|)>>|<cell|=>|<cell|<with|color|dark
      green|18466820999>>>|<row|<cell|<around*|(|P*Q|)><around*|(|1|)>>|<cell|=>|<cell|<with|color|dark
      red|91657624817>>>>>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<resize|<with|color|dark
      blue|<around*|(|P*Q|)><rsub|1>>=<with|color|dark
      red|<around*|(|P<rsub|0>+P<rsub|1>|)>*<around*|(|Q<rsub|0>+Q<rsub|1>|)>>-P<rsub|0>*Q<rsub|0>-<with|color|dark
      green|P<rsub|1>*Q<rsub|1>>|<plus|1l|2cm>||<plus|1r|-2cm>|>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<resize|P*Q=26779689992+<with|color|dark
      blue|46411113826>*X+<with|color|dark
      green|18466820999>*X<rsup|2>|<plus|1l|3cm>||<plus|1r|-3cm>|>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<tabular|<tformat|<cwith|3|3|1|1|cell-bborder|1ln>|<table|<row|<cell|26779689992<greyed|000000000000>>>|<row|<cell|<with|color|dark
      blue|<greyed|000000>46411113826<greyed|000000>>>>|<row|<cell|<with|color|dark
      green|<greyed|000000000000>18466820999>>>|<row|<cell|26779736403132292820999>>>>>>|<cell|>>>>>
    </equation*>
  </hidden>|<\hidden>
    <tit|Discrete Fourier Transform (DFT)>

    <strong|Definition>

    <\compact>
      <math|\<omega\>\<in\>\<bbb-K\>> primitive <math|N>-th root of unity,
      with <math|N\<in\>2<rsup|\<bbb-N\>>>

      <\eqnarray*>
        <tformat|<table|<row|<cell|DFT<rsub|\<omega\>><around*|(|P<rsub|0>,\<ldots\>,P<rsub|N-1>|)>>|<cell|=>|<cell|<around*|(|P<around*|(|1|)>,P<around*|(|\<omega\>|)>,P<around*|(|\<omega\><rsup|2>|)>,\<ldots\>,P<around*|(|\<omega\><rsup|N-1>|)>|)>>>>>
      </eqnarray*>

      Corresponds to evaluating <math|P=P<rsub|0>+\<cdots\>+P<rsub|N-1>*X<rsup|N-1>>
      at <math|x<rsub|i>=\<omega\><rsup|i>><vspace|1fn>
    </compact>

    <with|gr-mode|<tuple|edit|math-at>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.430001gh>>|gr-geometry|<tuple|geometry|1par|0.47825par|center>|gr-text-at-halign|center|<graphics||<line|<point|-3|4>|<point|-3.0|2.0>>|<line|<point|-1|4>|<point|-1.0|2.0>>|<line|<point|-5|4>|<point|-5.0|2.0>>|<line|<point|-7|4>|<point|-7.0|2.0>>|<line|<point|1|4>|<point|1.0|2.0>>|<line|<point|3|4>|<point|3.0|2.0>>|<line|<point|5|4>|<point|5.0|2.0>>|<line|<point|7|4>|<point|7.0|2.0>>|<line|<point|-7|4>|<point|-5.0|2.0>>|<line|<point|-7|2>|<point|-5.0|4.0>>|<line|<point|-3|4>|<point|-1.0|2.0>>|<line|<point|-3|2>|<point|-1.0|4.0>>|<line|<point|1|4>|<point|3.0|2.0>>|<line|<point|1|2>|<point|3.0|4.0>>|<line|<point|5|4>|<point|7.0|2.0>>|<line|<point|5|2>|<point|7.0|4.0>>|<line|<point|-7|2>|<point|-7.0|0.0>>|<line|<point|-3|2>|<point|-3.0|0.0>>|<line|<point|-5|2>|<point|-5.0|0.0>>|<line|<point|-1|2>|<point|-1.0|0.0>>|<line|<point|1|2>|<point|1.0|0.0>>|<line|<point|3|2>|<point|3.0|0.0>>|<line|<point|5|2>|<point|5.0|0.0>>|<line|<point|7|2>|<point|7.0|0.0>>|<spline|<point|-7|2>|<point|-4.5|1.0>|<point|-3.0|0.0>>|<spline|<point|-7|0>|<point|-4.5|1.0>|<point|-3.0|2.0>>|<spline|<point|-5|2>|<point|-2.5|1.0>|<point|-1.0|0.0>>|<spline|<point|-5|0>|<point|-2.5|1.0>|<point|-1.0|2.0>>|<spline|<point|1|2>|<point|3.5|1.0>|<point|5.0|0.0>>|<spline|<point|1|0>|<point|3.5|1.0>|<point|5.0|2.0>>|<spline|<point|3|2>|<point|5.5|1.0>|<point|7.0|0.0>>|<spline|<point|3|0>|<point|5.5|1.0>|<point|7.0|2.0>>|<line|<point|-7|0>|<point|-7.0|-2.0>>|<line|<point|-5|0>|<point|-5.0|-2.0>>|<line|<point|-3|0>|<point|-3.0|-2.0>>|<line|<point|-1|0>|<point|-1.0|-2.0>>|<line|<point|1|0>|<point|1.0|-2.0>>|<line|<point|3|0>|<point|3.0|-2.0>>|<line|<point|5|0>|<point|5.0|-2.0>>|<line|<point|7|0>|<point|7.0|-2.0>>|<spline|<point|-7|0>|<point|-2.5|-1.0>|<point|1.0|-2.0>>|<spline|<point|-7|-2>|<point|-2.5|-1.0>|<point|1.0|0.0>>|<spline|<point|-5|0>|<point|-0.5|-1.0>|<point|3.0|-2.0>>|<spline|<point|-5|-2>|<point|-0.5|-1.0>|<point|3.0|0.0>>|<spline|<point|-3|0>|<point|1.5|-1.0>|<point|5.0|-2.0>>|<spline|<point|-3|-2>|<point|1.5|-1.0>|<point|5.0|0.0>>|<spline|<point|-1|0>|<point|3.5|-1.0>|<point|7.0|-2.0>>|<spline|<point|-1|-2>|<point|3.5|-1.0>|<point|7.0|0.0>>|<point|-7|4>|<point|-5|4>|<point|-3|4>|<point|-1|4>|<point|1|4>|<point|3|4>|<point|5|4>|<point|7|4>|<point|-7|-2>|<point|-5|-2>|<point|-3|-2>|<point|-1|-2>|<point|1|-2>|<point|3|-2>|<point|5|-2>|<point|7|-2>|<math-at|<small|<with|color|red|\<omega\><rsup|3>>>|<point|6.25|2.25>>|<math-at|<small|<with|color|red|-1>>|<point|6.75|-1.0>>|<math-at|<small|<with|color|red|-1>>|<point|4.75|-1.0>>|<math-at|<small|<with|color|red|-1>>|<point|2.75|-0.5>>|<math-at|<small|<with|color|red|-1>>|<point|0.75|-0.363190752252219>>|<math-at|<small|<with|color|red|-1>>|<point|-1.25|0.75>>|<math-at|<small|<with|color|red|\<mathi\>>>|<point|-1.75|2.5>>|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|-1.19470495731571|3.0>>|<with|color|red|<math-at|<small|<with|color|red|-1>>|<point|-5.25|3.0>>>|<math-at|<small|<with|color|red|\<omega\>>>|<point|2.25|2.5>>|<math-at|<small|<with|color|red|-\<omega\>>>|<point|2.76680116417516|2.9579805529832>>|<math-at|<small|<with|color|red|\<mathi\>>>|<point|2.5|1.25>>|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|4.75|1.5>>|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|6.75|1.19072666073484>>|<math-at|<small|<with|color|red|-\<omega\><rsup|3>>>|<point|6.75|3.0>>|<math-at|<small|<with|color|red|-1>>|<point|-3.25|1.34520787991165>>|<math-at|<small|<with|color|red|\<mathi\>>>|<point|6.0|0.5>>|<with|text-at-halign|center|<math-at|P<rsub|0>|<point|-7|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|4>|<point|-5|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|2>|<point|-3|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|6>|<point|-1|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|1>|<point|1|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|5>|<point|3|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|3>|<point|5|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|7>|<point|7|4.25>>>|<with|text-at-halign|center|<math-at|P<around*|(|1|)>|<point|-7|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|\<omega\>|)>|<point|-5|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|\<mathi\>|)>|<point|-3|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|\<omega\><rsup|3>|)>|<point|-1|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|-<space|-0.4spc>1|)>|<point|1|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|\<omega\><rsup|5>|)>|<point|3|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|-<space|-0.4spc>\<mathi\>|)>|<point|5|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|\<omega\><rsup|7>|)>|<point|7|-2.75>>>>>
  </hidden>|<\hidden>
    <tit|Discrete Fourier Transform (DFT)>

    <unroll|<\shown>
      <strong|Definition>

      <\compact>
        <math|\<omega\>\<in\>\<bbb-K\>> primitive <math|N>-th root of unity,
        with <math|N\<in\>2<rsup|\<bbb-N\>>>

        <\eqnarray*>
          <tformat|<table|<row|<cell|DFT<rsub|\<omega\>><around*|(|P<rsub|0>,\<ldots\>,P<rsub|N-1>|)>>|<cell|=>|<cell|<around*|(|P<around*|(|1|)>,P<around*|(|\<omega\>|)>,P<around*|(|\<omega\><rsup|2>|)>,\<ldots\>,P<around*|(|\<omega\><rsup|N-1>|)>|)>>>>>
        </eqnarray*>

        Corresponds to evaluating <math|P=P<rsub|0>+\<cdots\>+P<rsub|N-1>*X<rsup|N-1>>
        at <math|x<rsub|i>=\<omega\><rsup|i>><vspace|1fn>
      </compact>
    </shown>|<\hidden*>
      <strong|Inverse transform>

      <\eqnarray*>
        <tformat|<table|<row|<cell|DFT<rsub|\<omega\>><rsup|-1>>|<cell|=>|<cell|<tfrac|1|N>*DFT<rsub|\<omega\><rsup|-1>>>>>>
      </eqnarray*>

      Interpolation <math|\<rightsquigarrow\>> evaluation<vspace|1fn>
    </hidden*>|<\hidden*>
      <strong|Variants>

      <\itemize>
        <item><math|\<bbb-K\>=\<bbb-C\><rsub|b>>: <strong|complex DFT>,
        complex fixed-point arithmetic with <math|b>-bit precision

        <item><math|\<bbb-K\>=\<bbb-F\><rsub|p>>, <strong|modular DFT>, with
        <math|p> prime number of the form <math|k*2<rsup|N>\<pm\>1> [Pollard
        71]

        <item><math|\<bbb-K\>=\<bbb-L\><around*|[|Y|]>/<around*|(|Y<rsup|2<rsup|N>>\<pm\>1|)>>,
        <strong|synthetic DFT>, <em| la> Schnhage--Strassen
      </itemize>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Discrete Fourier Transform (II) >

    \;

    <htab|5mm><with|gr-mode|<tuple|edit|line>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.399989par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|right|gr-text-at-valign|center|gr-auto-crop|true|<graphics||<point|-7|2>|<point|-6|2>|<point|-5|2>|<point|-4|2>|<point|-3|2>|<point|-2|2>|<point|-1|2>|<point|0|2>|<point|1|2>|<point|2|2>|<point|3|2>|<point|4|2>|<point|5|2>|<point|6|2>|<point|7|2>|<line|<point|-7|2>|<point|-6.0|1.0>>|<line|<point|-6|2>|<point|-7.0|1.0>>|<line|<point|-5|2>|<point|-4.0|1.0>>|<line|<point|-5|1>|<point|-4.0|2.0>>|<line|<point|-3|2>|<point|-2.0|1.0>>|<line|<point|-3|1>|<point|-2.0|2.0>>|<line|<point|-1|2>|<point|0.0|1.0>>|<line|<point|-1|1>|<point|0.0|2.0>>|<line|<point|1|2>|<point|2.0|1.0>>|<line|<point|1|1>|<point|2.0|2.0>>|<line|<point|3|2>|<point|4.0|1.0>>|<line|<point|3|1>|<point|4.0|2.0>>|<line|<point|5|2>|<point|6.0|1.0>>|<line|<point|5|1>|<point|6.0|2.0>>|<line|<point|7|2>|<point|8.0|1.0>>|<line|<point|7|1>|<point|8.0|2.0>>|<point|8|2>|<spline|<point|-7|1>|<point|-5.75|0.5>|<point|-5.0|0.0>>|<spline|<point|-7|0>|<point|-5.75|0.5>|<point|-5.0|1.0>>|<spline|<point|-6|1>|<point|-4.75|0.5>|<point|-4.0|0.0>>|<spline|<point|-6|0>|<point|-4.75|0.5>|<point|-4.0|1.0>>|<spline|<point|-3|1>|<point|-1.75|0.5>|<point|-1.0|0.0>>|<spline|<point|-3|0>|<point|-1.75|0.5>|<point|-1.0|1.0>>|<spline|<point|-2|1>|<point|-0.75|0.5>|<point|0.0|0.0>>|<spline|<point|-2|0>|<point|-0.75|0.5>|<point|0.0|1.0>>|<spline|<point|1|1>|<point|2.25|0.5>|<point|3.0|0.0>>|<spline|<point|2|1>|<point|3.25|0.5>|<point|4.0|0.0>>|<spline|<point|1|0>|<point|2.25|0.5>|<point|3.0|1.0>>|<spline|<point|2|0>|<point|3.25|0.5>|<point|4.0|1.0>>|<spline|<point|5|1>|<point|6.25|0.5>|<point|7.0|0.0>>|<spline|<point|6|1>|<point|7.25|0.5>|<point|8.0|0.0>>|<spline|<point|5|0>|<point|6.25|0.5>|<point|7.0|1.0>>|<spline|<point|6|0>|<point|7.25|0.5>|<point|8.0|1.0>>|<spline|<point|-7|0>|<point|-4.5|-0.5>|<point|-3.0|-1.0>>|<spline|<point|-7|-1>|<point|-4.5|-0.5>|<point|-3.0|0.0>>|<spline|<point|-6|0>|<point|-3.5|-0.5>|<point|-2.0|-1.0>>|<spline|<point|-6|-1>|<point|-3.5|-0.5>|<point|-2.0|0.0>>|<spline|<point|-5|0>|<point|-2.5|-0.5>|<point|-1.0|-1.0>>|<spline|<point|-5|-1>|<point|-2.5|-0.5>|<point|-1.0|0.0>>|<spline|<point|-4|0>|<point|-1.5|-0.5>|<point|0.0|-1.0>>|<spline|<point|-4|-1>|<point|-1.5|-0.5>|<point|0.0|0.0>>|<spline|<point|1|0>|<point|3.5|-0.5>|<point|5.0|-1.0>>|<spline|<point|1|-1>|<point|3.5|-0.5>|<point|5.0|0.0>>|<spline|<point|2|0>|<point|4.5|-0.5>|<point|6.0|-1.0>>|<spline|<point|2|-1>|<point|4.5|-0.5>|<point|6.0|0.0>>|<spline|<point|3|0>|<point|5.5|-0.5>|<point|7.0|-1.0>>|<spline|<point|3|-1>|<point|5.5|-0.5>|<point|7.0|0.0>>|<spline|<point|4|0>|<point|6.5|-0.5>|<point|8.0|-1.0>>|<spline|<point|4|-1>|<point|6.5|-0.5>|<point|8.0|0.0>>|<spline|<point|-7|-1>|<point|-2.0|-1.5>|<point|1.0|-2.0>>|<spline|<point|-7|-2>|<point|-2.0|-1.5>|<point|1.0|-1.0>>|<spline|<point|-6|-1>|<point|-1.0|-1.5>|<point|2.0|-2.0>>|<spline|<point|-6|-2>|<point|-1.0|-1.5>|<point|2.0|-1.0>>|<spline|<point|-5|-1>|<point|0.0|-1.5>|<point|3.0|-2.0>>|<spline|<point|-5|-2>|<point|0.0|-1.5>|<point|3.0|-1.0>>|<spline|<point|-4|-1>|<point|1.0|-1.5>|<point|4.0|-2.0>>|<spline|<point|-4|-2>|<point|1.0|-1.5>|<point|4.0|-1.0>>|<spline|<point|-3|-1>|<point|2.0|-1.5>|<point|5.0|-2.0>>|<spline|<point|-3|-2>|<point|2.0|-1.5>|<point|5.0|-1.0>>|<spline|<point|-2|-1>|<point|3.0|-1.5>|<point|6.0|-2.0>>|<spline|<point|-2|-2>|<point|3.0|-1.5>|<point|6.0|-1.0>>|<spline|<point|-1|-1>|<point|4.0|-1.5>|<point|7.0|-2.0>>|<spline|<point|-1|-2>|<point|4.0|-1.5>|<point|7.0|-1.0>>|<spline|<point|0|-1>|<point|5.0|-1.5>|<point|8.0|-2.0>>|<spline|<point|0|-2>|<point|5.0|-1.5>|<point|8.0|-1.0>>|<point|-7|-2>|<point|-6|-2>|<point|-5|-2>|<point|-4|-2>|<point|-3|-2>|<point|-2|-2>|<point|-1|-2>|<point|0|-2>|<point|1|-2>|<point|2|-2>|<point|3|-2>|<point|4|-2>|<point|5|-2>|<point|6|-2>|<point|7|-2>|<point|8|-2>|<with|color|dark
    grey|<spline|<point|-7.5|2>|<point|-7.75|0.0>|<point|-7.5|-2.0>>>|<with|color|dark
    grey|<spline|<point|-7|2.5>|<point|0.0|2.75>|<point|8.0|2.5>>>|<with|text-at-valign|center|text-at-halign|right|<math-at|lg
    N|<point|-8|0>>>|<line|<point|-7|2>|<point|-7.0|-2.0>>|<line|<point|-6|2>|<point|-6.0|-2.0>>|<line|<point|-5|2>|<point|-5.0|-2.0>>|<line|<point|-4|2>|<point|-4.0|-2.0>>|<line|<point|-3|2>|<point|-3.0|-2.0>>|<line|<point|-2|2>|<point|-2.0|-2.0>>|<line|<point|-1|2>|<point|-1.0|-2.0>>|<line|<point|0|2>|<point|0.0|-2.0>>|<line|<point|1|2>|<point|1.0|-2.0>>|<line|<point|2|2>|<point|2.0|-2.0>>|<line|<point|3|2>|<point|3.0|-2.0>>|<line|<point|4|2>|<point|4.0|-2.0>>|<line|<point|5|2>|<point|5.0|-2.0>>|<line|<point|6|2>|<point|6.0|-2.0>>|<line|<point|7|2>|<point|7.0|-2.0>>|<line|<point|8|2>|<point|8.0|-2.0>>|<with|text-at-halign|center|<math-at|N|<point|0.511046434713586|3.04903095647572>>>>><space|2em><htab|5mm>

    \;

    Cost of one DFT<nbsp>: <math|<frac|1|2>*N*lg N> ``butterflies''
    <math|\<rightsquigarrow\>> <math|O<around*|(|N*lg N|)>> operations in
    <math|\<bbb-K\>>

    \;

    <switch|<\shown>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|2|2|2|4|cell-tsep|1spc>|<cwith|2|2|2|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<table|<row|<cell|<pastel|Complex
      DFT>>|<cell|<pastel|<math|N\<asymp\>n/lg
      n>>>|<cell|<pastel|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>>|<cell|<pastel|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg
      n|)>>>>>|<row|<cell|<pastel|Modular
      DFT>>|<cell|<pastel|<math|N\<asymp\>n/lg
      n>>>|<cell|<pastel|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>>|<cell|<pastel|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg
      n|)>>>>>|<row|<cell|<pastel|Synthetic
      DFT>>|<cell|<pastel|<math|N\<asymp\><sqrt|n>>>>|<cell|<pastel|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>>|<cell|<pastel|<math|<math-ss|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<sqrt|n>+<sqrt|n>*<math-ss|I><around*|(|<sqrt|n>|)>|)>>>>>>>>>>
    </shown>|<\hidden>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|2|3|1|4|cell-tsep|1spc>|<cwith|2|3|1|4|cell-bsep|1spc>|<cwith|2|2|2|4|cell-tsep|1spc>|<cwith|2|2|2|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<table|<row|<cell|Complex
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg n|)>>>>|<row|<cell|<pastel|Modular
      DFT>>|<cell|<pastel|<math|N\<asymp\>n/lg
      n>>>|<cell|<pastel|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>>|<cell|<pastel|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg
      n|)>>>>>|<row|<cell|<pastel|Synthetic
      DFT>>|<cell|<pastel|<math|N\<asymp\><sqrt|n>>>>|<cell|<pastel|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>>|<cell|<pastel|<math|<math-ss|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<sqrt|n>+<sqrt|n>*<math-ss|I><around*|(|<sqrt|n>|)>|)>>>>>>>>>>
    </hidden>|<\hidden>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|3|3|1|4|cell-tsep|1spc>|<cwith|3|3|1|4|cell-bsep|1spc>|<cwith|3|3|1|4|cell-tsep|1spc>|<cwith|3|3|1|4|cell-bsep|1spc>|<table|<row|<cell|Complex
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg n|)>>>>|<row|<cell|Modular
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg
      n|)>>>>|<row|<cell|<pastel|Synthetic
      DFT>>|<cell|<pastel|<math|N\<asymp\><sqrt|n>>>>|<cell|<pastel|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>>|<cell|<pastel|<math|<math-ss|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<sqrt|n>+<sqrt|n>*<math-ss|I><around*|(|<sqrt|n>|)>|)>>>>>>>>>>
    </hidden>|<\hidden>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<table|<row|<cell|Complex
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg n|)>>>>|<row|<cell|Modular
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg n|)>>>>|<row|<cell|Synthetic
      DFT>|<cell|<math|N\<asymp\><sqrt|n>>>|<cell|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<sqrt|n>+<sqrt|n>*<math-ss|I><around*|(|<sqrt|n>|)>|)>>>>>>>
    </hidden>|<\hidden>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<table|<row|<cell|Complex
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg n*lg
      lg n*lg lg lg n*\<cdots\>|)>>>>|<row|<cell|Modular
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg n*lg
      lg n*lg lg lg n*\<cdots\>|)>>>>|<row|<cell|Synthetic
      DFT>|<cell|<math|N\<asymp\><sqrt|n>>>|<cell|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*lg lg n|)>>>>>>>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Variants of Discrete Fourier Transform>

    \;

    <switch|<\shown>
      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.526078par|center>|gr-text-at-halign|center|gr-text-at-valign|center|gr-fill-color|pastel
      blue|<graphics||<point|-0.5|4>|<point|-1.5|4>|<point|-2.5|4>|<point|-3.5|4>|<point|-4.5|4>|<point|-5.5|4>|<point|-6.5|4>|<point|-7.5|4>|<with|color|red|<line|<point|1.5|3.0>|<point|1.5|4.0>>>|<point|0.5|4>|<point|1.5|4>|<point|2.5|4>|<point|3.5|4>|<point|4.5|4>|<point|5.5|4>|<point|6.5|4>|<point|7.5|4>|<line|<point|-7.5|4>|<point|-7.5|3.0>>|<line|<point|-7.5|4>|<point|-6.5|3.0>>|<line|<point|-6.5|4>|<point|-6.5|3.0>>|<line|<point|-6.5|4>|<point|-7.5|3.0>>|<line|<point|-5.5|4>|<point|-5.5|3.0>>|<line|<point|-5.5|4>|<point|-4.5|3.0>>|<line|<point|-4.5|4>|<point|-4.5|3.0>>|<line|<point|-4.5|4>|<point|-5.5|3.0>>|<line|<point|-3.5|4>|<point|-3.5|3.0>|<point|-2.5|4.0>|<point|-2.5|3.0>|<point|-3.5|4.0>>|<line|<point|-1.5|4>|<point|-1.5|3.0>|<point|-0.5|4.0>|<point|-0.5|3.0>|<point|-1.5|4.0>>|<line|<point|2.5|4>|<point|2.5|3.0>|<point|3.5|4.0>|<point|3.5|3.0>|<point|2.5|4.0>>|<line|<point|4.5|4>|<point|4.5|3.0>|<point|5.5|4.0>|<point|5.5|3.0>|<point|4.5|4.0>>|<line|<point|6.5|4>|<point|6.5|3.0>|<point|7.5|4.0>|<point|7.5|3.0>|<point|6.5|4.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8|3>|<point|-8.0|2.0>|<point|8.0|2.0>|<point|8.0|3.0>>>|<line|<point|6.5|2.0>|<point|6.5|1.0>|<point|7.5|2.0>|<point|7.5|1.0>|<point|6.5|2.0>>|<line|<point|2.5|2.0>|<point|2.5|1.0>|<point|3.5|2.0>|<point|3.5|1.0>|<point|2.5|2.0>>|<line|<point|4.5|2.0>|<point|4.5|1.0>|<point|5.5|2.0>|<point|5.5|1.0>|<point|4.5|2.0>>|<line|<point|-1.5|2.0>|<point|-1.5|1.0>|<point|-0.5|2.0>|<point|-0.5|1.0>|<point|-1.5|2.0>>|<line|<point|-4.5|2.0>|<point|-4.5|1.0>>|<line|<point|-3.5|2.0>|<point|-3.5|1.0>|<point|-2.5|2.0>|<point|-2.5|1.0>|<point|-3.5|2.0>>|<line|<point|-5.5|2.0>|<point|-4.5|1.0>>|<line|<point|-4.5|2.0>|<point|-5.5|1.0>>|<line|<point|-5.5|2.0>|<point|-5.5|1.0>>|<line|<point|-6.5|2.0>|<point|-6.5|1.0>>|<line|<point|-7.5|2.0>|<point|-6.5|1.0>>|<line|<point|-6.5|2.0>|<point|-7.5|1.0>>|<line|<point|-7.5|2.0>|<point|-7.5|1.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8.0|1.0>|<point|-8.0|0.0>|<point|8.0|0.0>|<point|8.0|1.0>>>|<line|<point|6.5|0.0>|<point|6.5|-1.0>|<point|7.5|0.0>|<point|7.5|-1.0>|<point|6.5|0.0>>|<line|<point|4.5|0.0>|<point|4.5|-1.0>|<point|5.5|0.0>|<point|5.5|-1.0>|<point|4.5|0.0>>|<line|<point|2.5|0.0>|<point|2.5|-1.0>|<point|3.5|0.0>|<point|3.5|-1.0>|<point|2.5|0.0>>|<line|<point|-1.5|0.0>|<point|-1.5|-1.0>|<point|-0.5|0.0>|<point|-0.5|-1.0>|<point|-1.5|0.0>>|<line|<point|-3.5|0.0>|<point|-3.5|-1.0>|<point|-2.5|0.0>|<point|-2.5|-1.0>|<point|-3.5|0.0>>|<line|<point|-4.5|0.0>|<point|-4.5|-1.0>>|<line|<point|-5.5|0.0>|<point|-4.5|-1.0>>|<line|<point|-4.5|0.0>|<point|-5.5|-1.0>>|<line|<point|-5.5|0.0>|<point|-5.5|-1.0>>|<line|<point|-6.5|0.0>|<point|-6.5|-1.0>>|<line|<point|-7.5|0.0>|<point|-6.5|-1.0>>|<line|<point|-6.5|0.0>|<point|-7.5|-1.0>>|<line|<point|-7.5|0.0>|<point|-7.5|-1.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8.0|-1.0>|<point|-8.0|-2.0>|<point|8.0|-2.0>|<point|8.0|-1.0>>>|<line|<point|6.5|-2.0>|<point|6.5|-3.0>|<point|7.5|-2.0>|<point|7.5|-3.0>|<point|6.5|-2.0>>|<line|<point|4.5|-2.0>|<point|4.5|-3.0>|<point|5.5|-2.0>|<point|5.5|-3.0>|<point|4.5|-2.0>>|<line|<point|2.5|-2.0>|<point|2.5|-3.0>|<point|3.5|-2.0>|<point|3.5|-3.0>|<point|2.5|-2.0>>|<line|<point|-1.5|-2.0>|<point|-1.5|-3.0>|<point|-0.5|-2.0>|<point|-0.5|-3.0>|<point|-1.5|-2.0>>|<line|<point|-3.5|-2.0>|<point|-3.5|-3.0>|<point|-2.5|-2.0>|<point|-2.5|-3.0>|<point|-3.5|-2.0>>|<line|<point|-4.5|-2.0>|<point|-4.5|-3.0>>|<line|<point|-5.5|-2.0>|<point|-4.5|-3.0>>|<line|<point|-4.5|-2.0>|<point|-5.5|-3.0>>|<line|<point|-5.5|-2.0>|<point|-5.5|-3.0>>|<line|<point|-6.5|-2.0>|<point|-6.5|-3.0>>|<line|<point|-7.5|-2.0>|<point|-6.5|-3.0>>|<line|<point|-6.5|-2.0>|<point|-7.5|-3.0>>|<line|<point|-7.5|-2.0>|<point|-7.5|-3.0>>|<point|-7.5|-3>|<point|-6.5|-3>|<point|-5.5|-3>|<point|-4.5|-3>|<point|-3.5|-3>|<point|-2.5|-3>|<point|-1.5|-3>|<point|-0.5|-3>|<point|0.5|-3>|<point|1.5|-3>|<point|2.5|-3>|<point|3.5|-3>|<point|4.5|-3>|<point|5.5|-3>|<point|6.5|-3>|<point|7.5|-3>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation|<point|-4.0|2.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation|<point|-4.0|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation|<point|-4.0|-1.5>>>|<with|color|red|<line|<point|1.5|1.0>|<point|1.5|2.0>>>|<with|color|red|<line|<point|1.47936234951713|-1.0>|<point|1.47936234951713|0.0>>>|<with|color|red|<line|<point|1.5|-3.0>|<point|1.5|-2.0>>>|<with|color|red|<line|<point|1.5|4>|<point|0.5|3.0>>>|<with|color|red|<line|<point|1.5|2>|<point|0.5|1.0>>>|<with|color|red|<line|<point|1.5|-2>|<point|0.5|-3.0>>>|<with|opacity|50%|<line|<point|1.5|3>|<point|0.5|4.0>|<point|0.5|3.0>>>|<with|opacity|50%|<line|<point|1.5|1>|<point|0.5|2.0>|<point|0.5|1.0>>>|<with|color|red|<line|<point|1.47936234951713|0.0>|<point|0.5|-1.0>>>|<with|opacity|50%|<line|<point|1.47936|-1>|<point|0.5|0.0>|<point|0.5|-1.0>>>|<with|opacity|50%|<line|<point|1.5|-3>|<point|0.5|-2.0>|<point|0.5|-3.0>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<mathi\>>>|<point|1.0|1.75>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|1.75|1.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|3.75>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|3.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<omega\><rsup|2>>>|<point|2.0|-0.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<omega\><rsup|2>>>|<point|0.75|-0.255268746936776>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<omega\>>>|<point|0.75|-2.25>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<omega\>>>|<point|2.0|-2.5>>>>>
    </shown>|<\hidden>
      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.526078par|center>|gr-text-at-halign|center|gr-text-at-valign|center|gr-fill-color|pastel
      blue|<graphics||<point|-0.5|4>|<point|-1.5|4>|<point|-2.5|4>|<point|-3.5|4>|<point|-4.5|4>|<point|-5.5|4>|<point|-6.5|4>|<point|-7.5|4>|<with|color|red|<line|<point|1.5|3.0>|<point|1.5|4.0>>>|<point|0.5|4>|<point|1.5|4>|<point|2.5|4>|<point|3.5|4>|<point|4.5|4>|<point|5.5|4>|<point|6.5|4>|<point|7.5|4>|<line|<point|-7.5|4>|<point|-7.5|3.0>>|<line|<point|-7.5|4>|<point|-6.5|3.0>>|<line|<point|-6.5|4>|<point|-6.5|3.0>>|<line|<point|-6.5|4>|<point|-7.5|3.0>>|<line|<point|-5.5|4>|<point|-5.5|3.0>>|<line|<point|-5.5|4>|<point|-4.5|3.0>>|<line|<point|-4.5|4>|<point|-4.5|3.0>>|<line|<point|-4.5|4>|<point|-5.5|3.0>>|<line|<point|-3.5|4>|<point|-3.5|3.0>|<point|-2.5|4.0>|<point|-2.5|3.0>|<point|-3.5|4.0>>|<line|<point|-1.5|4>|<point|-1.5|3.0>|<point|-0.5|4.0>|<point|-0.5|3.0>|<point|-1.5|4.0>>|<line|<point|2.5|4>|<point|2.5|3.0>|<point|3.5|4.0>|<point|3.5|3.0>|<point|2.5|4.0>>|<line|<point|4.5|4>|<point|4.5|3.0>|<point|5.5|4.0>|<point|5.5|3.0>|<point|4.5|4.0>>|<line|<point|6.5|4>|<point|6.5|3.0>|<point|7.5|4.0>|<point|7.5|3.0>|<point|6.5|4.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8|3>|<point|-8.0|2.0>|<point|8.0|2.0>|<point|8.0|3.0>>>|<line|<point|6.5|2.0>|<point|6.5|1.0>|<point|7.5|2.0>|<point|7.5|1.0>|<point|6.5|2.0>>|<line|<point|2.5|2.0>|<point|2.5|1.0>|<point|3.5|2.0>|<point|3.5|1.0>|<point|2.5|2.0>>|<line|<point|4.5|2.0>|<point|4.5|1.0>|<point|5.5|2.0>|<point|5.5|1.0>|<point|4.5|2.0>>|<line|<point|-1.5|2.0>|<point|-1.5|1.0>|<point|-0.5|2.0>|<point|-0.5|1.0>|<point|-1.5|2.0>>|<line|<point|-4.5|2.0>|<point|-4.5|1.0>>|<line|<point|-3.5|2.0>|<point|-3.5|1.0>|<point|-2.5|2.0>|<point|-2.5|1.0>|<point|-3.5|2.0>>|<line|<point|-5.5|2.0>|<point|-4.5|1.0>>|<line|<point|-4.5|2.0>|<point|-5.5|1.0>>|<line|<point|-5.5|2.0>|<point|-5.5|1.0>>|<line|<point|-6.5|2.0>|<point|-6.5|1.0>>|<line|<point|-7.5|2.0>|<point|-6.5|1.0>>|<line|<point|-6.5|2.0>|<point|-7.5|1.0>>|<line|<point|-7.5|2.0>|<point|-7.5|1.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8.0|1.0>|<point|-8.0|0.0>|<point|8.0|0.0>|<point|8.0|1.0>>>|<line|<point|6.5|0.0>|<point|6.5|-1.0>|<point|7.5|0.0>|<point|7.5|-1.0>|<point|6.5|0.0>>|<line|<point|4.5|0.0>|<point|4.5|-1.0>|<point|5.5|0.0>|<point|5.5|-1.0>|<point|4.5|0.0>>|<line|<point|2.5|0.0>|<point|2.5|-1.0>|<point|3.5|0.0>|<point|3.5|-1.0>|<point|2.5|0.0>>|<line|<point|-1.5|0.0>|<point|-1.5|-1.0>|<point|-0.5|0.0>|<point|-0.5|-1.0>|<point|-1.5|0.0>>|<line|<point|-3.5|0.0>|<point|-3.5|-1.0>|<point|-2.5|0.0>|<point|-2.5|-1.0>|<point|-3.5|0.0>>|<line|<point|-4.5|0.0>|<point|-4.5|-1.0>>|<line|<point|-5.5|0.0>|<point|-4.5|-1.0>>|<line|<point|-4.5|0.0>|<point|-5.5|-1.0>>|<line|<point|-5.5|0.0>|<point|-5.5|-1.0>>|<line|<point|-6.5|0.0>|<point|-6.5|-1.0>>|<line|<point|-7.5|0.0>|<point|-6.5|-1.0>>|<line|<point|-6.5|0.0>|<point|-7.5|-1.0>>|<line|<point|-7.5|0.0>|<point|-7.5|-1.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8.0|-1.0>|<point|-8.0|-2.0>|<point|8.0|-2.0>|<point|8.0|-1.0>>>|<line|<point|6.5|-2.0>|<point|6.5|-3.0>|<point|7.5|-2.0>|<point|7.5|-3.0>|<point|6.5|-2.0>>|<line|<point|4.5|-2.0>|<point|4.5|-3.0>|<point|5.5|-2.0>|<point|5.5|-3.0>|<point|4.5|-2.0>>|<line|<point|2.5|-2.0>|<point|2.5|-3.0>|<point|3.5|-2.0>|<point|3.5|-3.0>|<point|2.5|-2.0>>|<line|<point|-1.5|-2.0>|<point|-1.5|-3.0>|<point|-0.5|-2.0>|<point|-0.5|-3.0>|<point|-1.5|-2.0>>|<line|<point|-3.5|-2.0>|<point|-3.5|-3.0>|<point|-2.5|-2.0>|<point|-2.5|-3.0>|<point|-3.5|-2.0>>|<line|<point|-4.5|-2.0>|<point|-4.5|-3.0>>|<line|<point|-5.5|-2.0>|<point|-4.5|-3.0>>|<line|<point|-4.5|-2.0>|<point|-5.5|-3.0>>|<line|<point|-5.5|-2.0>|<point|-5.5|-3.0>>|<line|<point|-6.5|-2.0>|<point|-6.5|-3.0>>|<line|<point|-7.5|-2.0>|<point|-6.5|-3.0>>|<line|<point|-6.5|-2.0>|<point|-7.5|-3.0>>|<line|<point|-7.5|-2.0>|<point|-7.5|-3.0>>|<point|-7.5|-3>|<point|-6.5|-3>|<point|-5.5|-3>|<point|-4.5|-3>|<point|-3.5|-3>|<point|-2.5|-3>|<point|-1.5|-3>|<point|-0.5|-3>|<point|0.5|-3>|<point|1.5|-3>|<point|2.5|-3>|<point|3.5|-3>|<point|4.5|-3>|<point|5.5|-3>|<point|6.5|-3>|<point|7.5|-3>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation
      + twiddle|<point|-4.0|2.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation
      + twiddle|<point|-4.0|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation
      + twiddle|<point|-4.0|-1.5>>>|<with|color|red|<line|<point|1.5|1.0>|<point|1.5|2.0>>>|<with|color|red|<line|<point|1.47936234951713|-1.0>|<point|1.47936234951713|0.0>>>|<with|color|red|<line|<point|1.5|-3.0>|<point|1.5|-2.0>>>|<with|color|red|<line|<point|1.5|4>|<point|0.5|3.0>>>|<with|color|red|<line|<point|1.5|2>|<point|0.5|1.0>>>|<with|color|red|<line|<point|1.5|-2>|<point|0.5|-3.0>>>|<with|opacity|50%|<line|<point|1.5|3>|<point|0.5|4.0>|<point|0.5|3.0>>>|<with|opacity|50%|<line|<point|1.5|1>|<point|0.5|2.0>|<point|0.5|1.0>>>|<with|color|red|<line|<point|1.47936234951713|0.0>|<point|0.5|-1.0>>>|<with|opacity|50%|<line|<point|1.47936|-1>|<point|0.5|0.0>|<point|0.5|-1.0>>>|<with|opacity|50%|<line|<point|1.5|-3>|<point|0.5|-2.0>|<point|0.5|-3.0>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|1.75>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|1.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|3.75>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|3.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|-0.25>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|-0.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|-2.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|-2.25>>>>>
    </hidden>|<\hidden>
      <with|gr-mode|<tuple|group-edit|props>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.526078par|center>|gr-text-at-halign|center|gr-text-at-valign|center|gr-fill-color|pastel
      blue|<graphics||<point|-0.5|4>|<point|-1.5|4>|<point|-2.5|4>|<point|-3.5|4>|<point|-4.5|4>|<point|-5.5|4>|<point|-6.5|4>|<point|-7.5|4>|<point|0.5|4>|<point|1.5|4>|<point|2.5|4>|<point|3.5|4>|<point|4.5|4>|<point|5.5|4>|<point|6.5|4>|<point|7.5|4>|<with|fill-color|pastel
      blue|<cline|<point|-8.0|1.0>|<point|-8.0|0.0>|<point|8.0|0.0>|<point|8.0|1.0>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation
      + twiddle|<point|-4.0|0.5>>>|<line|<point|-6.5|4>|<point|-7.5|2.5>>|<line|<point|-7.5|4>|<point|-7.5|2.5>>|<line|<point|-6.5|4>|<point|-6.5|2.5>>|<line|<point|-7.5|4>|<point|-6.5|2.5>>|<line|<point|-4.5|4>|<point|-5.5|2.5>>|<line|<point|-5.5|4>|<point|-5.5|2.5>>|<line|<point|-4.5|4>|<point|-4.5|2.5>>|<line|<point|-5.5|4>|<point|-4.5|2.5>>|<line|<point|-3.5|4>|<point|-3.5|2.5>|<point|-2.5|4.0>|<point|-2.5|2.5>|<point|-3.5|4.0>>|<line|<point|-1.5|4>|<point|-1.5|2.5>|<point|-0.5|4.0>|<point|-0.5|2.5>|<point|-1.5|4.0>>|<line|<point|-7.5|2.5>|<point|-7.5|1.0>>|<line|<point|-5.5|2.5>|<point|-5.5|1.0>>|<line|<point|-6.5|2.5>|<point|-6.5|1.0>>|<line|<point|-4.5|2.5>|<point|-4.5|1.0>>|<spline|<point|-7.5|2.5>|<point|-6.25|1.75>|<point|-5.5|1.0>>|<spline|<point|-7.5|1>|<point|-6.25|1.75>|<point|-5.5|2.5>>|<spline|<point|-6.5|2.5>|<point|-5.25|1.75>|<point|-4.5|1.0>>|<spline|<point|-6.5|1>|<point|-5.25|1.75>|<point|-4.5|2.5>>|<with|opacity|50%|<line|<point|1.5|2.5>|<point|1.5|4.0>>>|<line|<point|4.5|4>|<point|4.5|2.5>|<point|5.5|4.0>|<point|5.5|2.5>|<point|4.5|4.0>>|<line|<point|6.5|4>|<point|6.5|2.5>|<point|7.5|4.0>|<point|7.5|2.5>|<point|6.5|4.0>>|<with|opacity|50%|<line|<point|0.5|1>|<point|0.5|2.5>>>|<with|opacity|50%|<spline|<point|0.5|1>|<point|1.75|1.75>|<point|2.5|2.5>>>|<with|opacity|50%|<line|<point|1.5|2.5>|<point|1.5|1.0>>>|<with|color|red|<spline|<point|1.5|1>|<point|2.75|1.75>|<point|3.5|2.5>>>|<with|opacity|50%|<spline|<point|1.5|2.5>|<point|2.75|1.75>|<point|3.5|1.0>>>|<with|color|red|<line|<point|3.5|2.5>|<point|3.5|1.0>>>|<with|opacity|50%|<line|<point|2.5|2.5>|<point|2.5|1.0>>>|<with|opacity|50%|<spline|<point|0.5|2.5>|<point|1.75|1.75>|<point|2.5|1.0>>>|<with|opacity|50%|<line|<point|0.5|2.5>|<point|1.5|4.0>>>|<with|opacity|50%|<line|<point|0.5|2.5>|<point|0.5|4.0>|<point|1.5|2.5>>>|<with|opacity|50%|<line|<point|2.5|4>|<point|2.5|2.5>>>|<with|opacity|50%|<line|<point|2.5|4>|<point|3.5|2.5>>>|<with|color|red|<line|<point|2.5|2.5>|<point|3.5|4.0>>>|<with|color|red|<line|<point|3.5|4>|<point|3.5|2.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|3.75|3.39652167877572>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<mathi\>>>|<point|3.0|3.75>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|3.75|1.90928791769621>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|3.0|2.25>>>|<spline|<point|-3.5|2.5>|<point|-2.25|1.75>|<point|-1.5|1.0>>|<spline|<point|-3.5|1>|<point|-2.25|1.75>|<point|-1.5|2.5>>|<spline|<point|-2.5|2.5>|<point|-1.25|1.75>|<point|-0.5|1.0>>|<spline|<point|-2.5|1>|<point|-1.25|1.75>|<point|-0.5|2.5>>|<spline|<point|4.5|2.5>|<point|5.75|1.75>|<point|6.5|1.0>>|<spline|<point|4.5|1>|<point|5.75|1.75>|<point|6.5|2.5>>|<spline|<point|5.5|2.5>|<point|6.75|1.75>|<point|7.5|1.0>>|<spline|<point|5.5|1>|<point|6.75|1.75>|<point|7.5|2.5>>|<line|<point|-3.5|2.5>|<point|-3.5|1.0>>|<line|<point|-2.5|2.5>|<point|-2.5|1.0>>|<line|<point|-1.5|2.5>|<point|-1.5|1.0>>|<line|<point|-0.5|2.5>|<point|-0.5|1.0>>|<line|<point|4.5|2.5>|<point|4.5|1.0>>|<line|<point|5.5|2.5>|<point|5.5|1.0>>|<line|<point|6.5|2.5>|<point|6.5|1.0>>|<line|<point|7.5|2.5>|<point|7.5|1.0>>|<line|<point|7.5|-1.5>|<point|7.5|-3.0>>|<line|<point|6.5|0.0>|<point|6.5|-1.5>|<point|7.5|0.0>|<point|7.5|-1.5>|<point|6.5|0.0>>|<line|<point|6.5|-1.5>|<point|6.5|-3.0>>|<spline|<point|5.5|-1.5>|<point|6.75|-2.25>|<point|7.5|-3.0>>|<spline|<point|5.5|-3.0>|<point|6.75|-2.25>|<point|7.5|-1.5>>|<line|<point|5.5|-1.5>|<point|5.5|-3.0>>|<line|<point|4.5|0.0>|<point|4.5|-1.5>|<point|5.5|0.0>|<point|5.5|-1.5>|<point|4.5|0.0>>|<spline|<point|4.5|-1.5>|<point|5.75|-2.25>|<point|6.5|-3.0>>|<spline|<point|4.5|-3.0>|<point|5.75|-2.25>|<point|6.5|-1.5>>|<line|<point|4.5|-1.5>|<point|4.5|-3.0>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|3.75|-0.60347832122428>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|3.75|-2.09071208230379>>>|<with|color|red|<line|<point|3.5|0.0>|<point|3.5|-1.5>>>|<with|color|red|<line|<point|3.5|-1.5>|<point|3.5|-3.0>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<mathi\>>>|<point|3.0|-0.25>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|3.0|-1.75>>>|<with|opacity|50%|<line|<point|2.5|0.0>|<point|3.5|-1.5>>>|<with|opacity|50%|<line|<point|2.5|0.0>|<point|2.5|-1.5>>>|<with|color|red|<line|<point|2.5|-1.5>|<point|3.5|0.0>>>|<with|opacity|50%|<line|<point|2.5|-1.5>|<point|2.5|-3.0>>>|<with|opacity|50%|<line|<point|1.5|-1.5>|<point|1.5|0.0>>>|<with|opacity|50%|<spline|<point|1.5|-1.5>|<point|2.75|-2.25>|<point|3.5|-3.0>>>|<with|opacity|50%|<line|<point|1.5|-1.5>|<point|1.5|-3.0>>>|<with|color|red|<spline|<point|1.5|-3.0>|<point|2.75|-2.25>|<point|3.5|-1.5>>>|<with|opacity|50%|<spline|<point|0.5|-1.5>|<point|1.75|-2.25>|<point|2.5|-3.0>>>|<with|opacity|50%|<line|<point|0.5|-1.5>|<point|1.5|0.0>>>|<with|opacity|50%|<line|<point|0.5|-1.5>|<point|0.5|0.0>|<point|1.5|-1.5>>>|<with|opacity|50%|<line|<point|0.5|-3.0>|<point|0.5|-1.5>>>|<with|opacity|50%|<spline|<point|0.5|-3.0>|<point|1.75|-2.25>|<point|2.5|-1.5>>>|<line|<point|-0.5|-1.5>|<point|-0.5|-3.0>>|<line|<point|-1.5|0.0>|<point|-1.5|-1.5>|<point|-0.5|0.0>|<point|-0.5|-1.5>|<point|-1.5|0.0>>|<line|<point|-1.5|-1.5>|<point|-1.5|-3.0>>|<spline|<point|-2.5|-1.5>|<point|-1.25|-2.25>|<point|-0.5|-3.0>>|<spline|<point|-2.5|-3.0>|<point|-1.25|-2.25>|<point|-0.5|-1.5>>|<line|<point|-2.5|-1.5>|<point|-2.5|-3.0>>|<line|<point|-3.5|0.0>|<point|-3.5|-1.5>|<point|-2.5|0.0>|<point|-2.5|-1.5>|<point|-3.5|0.0>>|<spline|<point|-3.5|-1.5>|<point|-2.25|-2.25>|<point|-1.5|-3.0>>|<spline|<point|-3.5|-3.0>|<point|-2.25|-2.25>|<point|-1.5|-1.5>>|<line|<point|-3.5|-1.5>|<point|-3.5|-3.0>>|<line|<point|-4.5|0.0>|<point|-4.5|-1.5>>|<line|<point|-5.5|0.0>|<point|-4.5|-1.5>>|<line|<point|-4.5|-1.5>|<point|-4.5|-3.0>>|<line|<point|-4.5|0.0>|<point|-5.5|-1.5>>|<line|<point|-5.5|0.0>|<point|-5.5|-1.5>>|<line|<point|-5.5|-1.5>|<point|-5.5|-3.0>>|<line|<point|-6.5|0.0>|<point|-6.5|-1.5>>|<line|<point|-7.5|0.0>|<point|-6.5|-1.5>>|<spline|<point|-6.5|-1.5>|<point|-5.25|-2.25>|<point|-4.5|-3.0>>|<line|<point|-6.5|0.0>|<point|-7.5|-1.5>>|<line|<point|-7.5|0.0>|<point|-7.5|-1.5>>|<spline|<point|-7.5|-1.5>|<point|-6.25|-2.25>|<point|-5.5|-3.0>>|<line|<point|-6.5|-1.5>|<point|-6.5|-3.0>>|<spline|<point|-6.5|-3.0>|<point|-5.25|-2.25>|<point|-4.5|-1.5>>|<line|<point|-7.5|-1.5>|<point|-7.5|-3.0>>|<spline|<point|-7.5|-3.0>|<point|-6.25|-2.25>|<point|-5.5|-1.5>>|<point|-7.5|-3.0>|<point|-6.5|-3.0>|<point|-5.5|-3.0>|<point|-4.5|-3.0>|<point|-3.5|-3.0>|<point|-2.5|-3.0>|<point|-1.5|-3.0>|<point|-0.5|-3.0>|<point|0.5|-3.0>|<point|1.5|-3.0>|<point|2.5|-3.0>|<point|3.5|-3.0>|<point|4.5|-3.0>|<point|5.5|-3.0>|<point|6.5|-3.0>|<point|7.5|-3.0>>>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Giant butterflies>

    <with|gr-mode|<tuple|edit|spline>|gr-frame|<tuple|scale|1.18933cm|<tuple|0.534985gw|0.304451gh>>|gr-geometry|<tuple|geometry|1par|0.582555par|center>|gr-text-at-halign|right|gr-text-at-valign|center|magnify|1.18920711391541|<graphics||<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-0.91602725228205|1.41308374123562>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-2.97946156899061|1.42766900383648>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-4.94461899722185|1.49186400317503>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-4.9141878995899|-1.46738466860694>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-6.98696870392909|-1.53085312475194>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-2.95493735057547|-1.44701266966529>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-0.99568348101601|-1.42663960444502>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-7.0015694434449|4.53552350840059>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-5.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-3.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-1.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-7.0|1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|1.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|3.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|5.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|7.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|1.0|-1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|3.0|-1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|5.0|-1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|7.0|-1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|7.0|1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|5.0|1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|3.0|1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|1.0|1.5>>>|<point|-7.75|6>|<point|-7.25|6>|<point|-6.75|6>|<point|-6.25|6>|<point|-5.75|6>|<point|-5.25|6>|<point|-4.75|6>|<point|-4.25|6>|<point|-3.75|6>|<point|-3.25|6>|<point|-2.75|6>|<point|-2.25|6>|<point|-1.75|6>|<point|-1.25|6>|<point|-0.75|6>|<point|-0.25|6>|<point|0.25|6>|<point|0.75|6>|<point|1.25|6>|<point|1.75|6>|<point|2.25|6>|<point|2.75|6>|<point|3.25|6>|<point|3.75|6>|<point|4.25|6>|<point|4.75|6>|<point|5.25|6>|<point|5.75|6>|<point|6.25|6>|<point|6.75|6>|<point|7.25|6>|<point|7.75|6>|<line|<point|-7.75|-2.30501541725267>|<point|-7.75|-3.0>>|<line|<point|-7.25|-2.30267047427459>|<point|-7.25|-3.0>>|<line|<point|-6.75|-2.30032553129652>|<point|-6.75|-3.0>>|<line|<point|-6.25|-2.29798058831844>|<point|-6.25|-3.0>>|<line|<point|-5.75|-2.29563564534036>|<point|-5.75|-3.0>>|<line|<point|-5.25|-2.29329070236228>|<point|-5.25|-3.0>>|<line|<point|-4.75|-2.29094575938421>|<point|-4.75|-3.0>>|<line|<point|-4.25|-2.28860081640613>|<point|-4.25|-3.0>>|<line|<point|-3.75|-2.28625587342805>|<point|-3.75|-3.0>>|<line|<point|-3.25|-2.28391093044997>|<point|-3.25|-3.0>>|<line|<point|-2.75|-2.2815659874719>|<point|-2.75|-3.0>>|<line|<point|-2.25|-2.27922104449382>|<point|-2.25|-3.0>>|<line|<point|-1.75|-2.27687610151574>|<point|-1.75|-3.0>>|<line|<point|-1.25|-2.27453115853766>|<point|-1.25|-3.0>>|<line|<point|-0.75|-2.27218621555958>|<point|-0.75|-3.0>>|<line|<point|-0.25|-2.26984127258151>|<point|-0.249999999999999|-3.0>>|<line|<point|0.25|-2.26749632960343>|<point|0.25|-3.01696973433462>>|<line|<point|0.75|-2.26515138662535>|<point|0.75|-3.01696973433462>>|<line|<point|1.25|-2.26280644364727>|<point|1.25|-3.01696973433462>>|<line|<point|1.75|-2.2604615006692>|<point|1.75|-3.01696973433462>>|<line|<point|2.25|-2.25811655769112>|<point|2.25|-3.01696973433462>>|<line|<point|2.75|-2.25577161471304>|<point|2.75|-3.01696973433462>>|<line|<point|3.25|-2.25342667173496>|<point|3.25|-3.01696973433462>>|<line|<point|3.75|-2.25108172875689>|<point|3.75|-3.01696973433462>>|<line|<point|4.25|-2.25>|<point|4.25|-3.01696973433462>>|<line|<point|4.75|-2.25>|<point|4.75|-3.01696973433462>>|<line|<point|5.25|-2.24404689982265>|<point|5.25|-3.01696973433462>>|<line|<point|5.75|-2.25>|<point|5.75|-3.01696973433462>>|<line|<point|6.25|-2.25>|<point|6.25|-3.01696973433462>>|<line|<point|6.75|-2.25>|<point|6.75|-3.01696973433462>>|<line|<point|7.25|-2.25>|<point|7.25|-3.01696973433462>>|<line|<point|7.75|-2.25>|<point|7.75|-3.01696973433462>>|<line|<point|7.75|3.78049026359429>|<point|7.75|3.28049026359429>>|<line|<point|7.25|3.78049026359429>|<point|7.25|3.28049026359429>>|<line|<point|6.75|3.78049026359429>|<point|6.75|3.28049026359429>>|<line|<point|6.25|3.78049026359429>|<point|6.25|3.28049026359429>>|<line|<point|5.75|3.78049026359429>|<point|5.75|3.28049026359429>>|<line|<point|5.25|3.78049026359429>|<point|5.25|3.28049026359429>>|<line|<point|4.75|3.78049026359429>|<point|4.75|3.28049026359429>>|<line|<point|4.25|3.78049026359429>|<point|4.25|3.28049026359429>>|<line|<point|3.75|3.78049026359429>|<point|3.75|3.28049026359429>>|<line|<point|3.25|3.78049026359429>|<point|3.25|3.28049026359429>>|<line|<point|2.75|3.78049026359429>|<point|2.75|3.28049026359429>>|<line|<point|2.25|3.78049026359429>|<point|2.25|3.28049026359429>>|<line|<point|1.75|3.78049026359429>|<point|1.75|3.28049026359429>>|<line|<point|1.25|3.78049026359429>|<point|1.25|3.28049026359429>>|<line|<point|0.75|3.78049026359429>|<point|0.75|3.28049026359429>>|<line|<point|0.25|3.78049026359429>|<point|0.25|3.28049026359429>>|<line|<point|0.25|0.77619323872997>|<point|0.25|0.27619323872997>>|<line|<point|0.75|0.77619323872997>|<point|0.75|0.27619323872997>>|<line|<point|1.25|0.77619323872997>|<point|1.25|0.27619323872997>>|<line|<point|1.75|0.77619323872997>|<point|1.75|0.27619323872997>>|<line|<point|2.25|0.77619323872997>|<point|2.25|0.27619323872997>>|<line|<point|2.75|0.77619323872997>|<point|2.75|0.27619323872997>>|<line|<point|3.25|0.77619323872997>|<point|3.25|0.27619323872997>>|<line|<point|3.75|0.77619323872997>|<point|3.75|0.27619323872997>>|<line|<point|4.25|0.77619323872997>|<point|4.25|0.27619323872997>>|<line|<point|4.75|0.77619323872997>|<point|4.75|0.27619323872997>>|<line|<point|5.25|0.77619323872997>|<point|5.25|0.27619323872997>>|<line|<point|5.75|0.77619323872997>|<point|5.75|0.27619323872997>>|<line|<point|6.25|0.77619323872997>|<point|6.25|0.27619323872997>>|<line|<point|6.75|0.77619323872997>|<point|6.75|0.27619323872997>>|<line|<point|7.25|0.77619323872997>|<point|7.25|0.27619323872997>>|<line|<point|7.75|0.77619323872997>|<point|7.75|0.27619323872997>>|<line|<point|7.75|2.75>|<point|7.75|2.25>>|<line|<point|7.25|2.75>|<point|7.25|2.25>>|<line|<point|6.75|2.75>|<point|6.75|2.25>>|<line|<point|6.25|2.75>|<point|6.25|2.25>>|<line|<point|5.75|2.75>|<point|5.75|2.25>>|<line|<point|5.25|2.75>|<point|5.25|2.25>>|<line|<point|4.75|2.75>|<point|4.75|2.25>>|<line|<point|4.25|2.75>|<point|4.25|2.25>>|<line|<point|3.75|2.75>|<point|3.75|2.25>>|<line|<point|3.25|2.75>|<point|3.25|2.25>>|<line|<point|2.75|2.75>|<point|2.75|2.25>>|<line|<point|2.25|2.75>|<point|2.25|2.25>>|<line|<point|1.75|2.75>|<point|1.75|2.25>>|<line|<point|1.25|2.75>|<point|1.25|2.25>>|<line|<point|0.75|2.75>|<point|0.75|2.25>>|<line|<point|0.25|2.75>|<point|0.25|2.25>>|<line|<point|7.75|-0.25>|<point|7.75|-0.75>>|<line|<point|7.25|-0.25>|<point|7.25|-0.75>>|<line|<point|6.75|-0.25>|<point|6.75|-0.75>>|<line|<point|6.25|-0.25>|<point|6.25|-0.75>>|<line|<point|5.75|-0.25>|<point|5.75|-0.75>>|<line|<point|5.25|-0.25>|<point|5.25|-0.75>>|<line|<point|4.75|-0.25>|<point|4.75|-0.75>>|<line|<point|4.25|-0.25>|<point|4.25|-0.75>>|<line|<point|3.75|-0.25>|<point|3.75|-0.75>>|<line|<point|3.25|-0.25>|<point|3.25|-0.75>>|<line|<point|2.75|-0.25>|<point|2.75|-0.75>>|<line|<point|2.25|-0.25>|<point|2.25|-0.75>>|<line|<point|1.75|-0.25>|<point|1.75|-0.75>>|<line|<point|1.25|-0.25>|<point|1.25|-0.75>>|<line|<point|0.75|-0.25>|<point|0.75|-0.75>>|<line|<point|0.25|-0.25>|<point|0.25|-0.75>>|<line|<point|-0.249999999999999|-0.25>|<point|-0.249999999999999|-0.75>>|<line|<point|-0.75|-0.25>|<point|-0.75|-0.75>>|<line|<point|-1.25|-0.25>|<point|-1.25|-0.75>>|<line|<point|-1.75|-0.25>|<point|-1.75|-0.75>>|<line|<point|-2.25|-0.25>|<point|-2.25|-0.75>>|<line|<point|-2.75|-0.25>|<point|-2.75|-0.75>>|<line|<point|-3.25|-0.25>|<point|-3.25|-0.75>>|<line|<point|-3.75|-0.25>|<point|-3.75|-0.75>>|<line|<point|-4.25|-0.25>|<point|-4.25|-0.75>>|<line|<point|-4.75|-0.25>|<point|-4.75|-0.75>>|<line|<point|-5.25|-0.25>|<point|-5.25|-0.75>>|<line|<point|-5.75|-0.25>|<point|-5.75|-0.75>>|<line|<point|-6.25|-0.25>|<point|-6.25|-0.75>>|<line|<point|-6.75|-0.25>|<point|-6.75|-0.75>>|<line|<point|-7.25|-0.25>|<point|-7.25|-0.75>>|<line|<point|-7.75|-0.25>|<point|-7.75|-0.75>>|<line|<point|-0.249999999999999|0.75>|<point|-0.249999999999999|0.25>>|<line|<point|-0.749999999999999|0.75>|<point|-0.749999999999999|0.25>>|<line|<point|-1.25|0.75>|<point|-1.25|0.25>>|<line|<point|-1.75|0.75>|<point|-1.75|0.25>>|<line|<point|-2.25|0.75>|<point|-2.25|0.25>>|<line|<point|-2.75|0.75>|<point|-2.75|0.25>>|<line|<point|-3.25|0.75>|<point|-3.25|0.25>>|<line|<point|-3.75|0.75>|<point|-3.75|0.25>>|<line|<point|-4.25|0.75>|<point|-4.25|0.25>>|<line|<point|-4.75|0.75>|<point|-4.75|0.25>>|<line|<point|-5.25|0.75>|<point|-5.25|0.25>>|<line|<point|-5.75|0.75>|<point|-5.75|0.25>>|<line|<point|-6.25|0.75>|<point|-6.25|0.25>>|<line|<point|-6.75|0.75>|<point|-6.75|0.25>>|<line|<point|-7.25|0.75>|<point|-7.25|0.25>>|<line|<point|-7.75|0.75>|<point|-7.75|0.25>>|<line|<point|-0.25|3.75>|<point|-0.25|3.25>>|<line|<point|-0.75|3.75>|<point|-0.75|3.25>>|<line|<point|-1.25|3.75>|<point|-1.25|3.25>>|<line|<point|-1.75|3.75>|<point|-1.75|3.25>>|<line|<point|-2.25|3.75>|<point|-2.25|3.25>>|<line|<point|-2.75|3.75>|<point|-2.75|3.25>>|<line|<point|-3.25|3.75>|<point|-3.25|3.25>>|<line|<point|-3.75|3.75>|<point|-3.75|3.25>>|<line|<point|-4.25|3.75>|<point|-4.25|3.25>>|<line|<point|-4.75|3.75>|<point|-4.75|3.25>>|<line|<point|-5.25|3.75>|<point|-5.25|3.25>>|<line|<point|-5.75|3.75>|<point|-5.75|3.25>>|<line|<point|-6.25|3.75>|<point|-6.25|3.25>>|<line|<point|-6.75|3.75>|<point|-6.75|3.25>>|<line|<point|-7.25|3.75>|<point|-7.25|3.25>>|<line|<point|-7.75|3.75>|<point|-7.75|3.25>>|<line|<point|-0.25|2.75>|<point|-0.25|2.25>>|<line|<point|-0.75|2.75>|<point|-0.75|2.25>>|<line|<point|-1.25|2.75>|<point|-1.25|2.25>>|<line|<point|-1.75|2.75>|<point|-1.75|2.25>>|<line|<point|-2.25|2.75>|<point|-2.25|2.25>>|<line|<point|-2.75|2.75>|<point|-2.75|2.25>>|<line|<point|-3.25|2.75>|<point|-3.25|2.25>>|<line|<point|-3.75|2.75>|<point|-3.75|2.25>>|<line|<point|-4.25|2.75>|<point|-4.25|2.25>>|<line|<point|-4.75|2.75>|<point|-4.75|2.25>>|<line|<point|-5.25|2.75>|<point|-5.25|2.25>>|<line|<point|-5.75|2.75>|<point|-5.75|2.25>>|<line|<point|-6.25|2.75>|<point|-6.25|2.25>>|<line|<point|-6.75|2.75>|<point|-6.75|2.25>>|<line|<point|-7.25|2.75>|<point|-7.25|2.25>>|<line|<point|-7.75|2.75>|<point|-7.75|2.25>>|<point|7.75|-3.0>|<point|7.25|-3.0>|<point|6.75|-3.0>|<point|6.25|-3.0>|<point|5.75|-3.0>|<point|5.25|-3.0>|<point|4.75|-3.0>|<point|4.25|-3.0>|<point|3.75|-3.0>|<point|3.25|-3.0>|<point|2.75|-3.0>|<point|2.25|-3.0>|<point|1.75|-3.0>|<point|1.25|-3.0>|<point|0.75|-3.0>|<point|0.249999999999999|-3.0>|<point|-0.250000000000001|-3.0>|<point|-0.75|-3.0>|<point|-1.25|-3.0>|<point|-1.75|-3.0>|<point|-2.25|-3.0>|<point|-2.75|-3.0>|<point|-3.25|-3.0>|<point|-3.75|-3.0>|<point|-4.25|-3.0>|<point|-4.75|-3.0>|<point|-5.25|-3.0>|<point|-5.75|-3.0>|<point|-6.25|-3.0>|<point|-6.75|-3.0>|<point|-7.25|-3.0>|<point|-7.75|-3.0>|<cline|<point|8.0|-2.25>|<point|8.0|-0.75>|<point|-8.0|-0.75>|<point|-8.0|-2.25>>|<line|<point|6|-2.25>|<point|6.0|-0.75>>|<line|<point|4|-2.25>|<point|4.0|-0.75>>|<line|<point|2|-2.25>|<point|2.0|-0.75>>|<line|<point|0|-2.25>|<point|0.0|-0.75>>|<line|<point|-2|-2.25>|<point|-2.0|-0.75>>|<line|<point|-2|0.75>|<point|-2.0|2.25>>|<line|<point|0|0.75>|<point|0.0|2.25>>|<line|<point|2|0.72892>|<point|2.0|2.25>>|<line|<point|4|0.75>|<point|4.0|2.25>>|<line|<point|6|0.75>|<point|6.0|2.25>>|<with|fill-color|pastel
    blue|<cline|<point|-8.0|0.25>|<point|-8.0|-0.25>|<point|8.0|-0.25>|<point|8.0|0.25>>>|<line|<point|-6|-2.25>|<point|-6.0|-0.75>>|<line|<point|-4|-2.25>|<point|-4.0|-0.75>>|<line|<point|-4|0.75>|<point|-4.0|2.25>>|<cline|<point|8.0|2.25>|<point|8.0|0.75>|<point|-8.0|0.75>|<point|-8.0|2.25>>|<line|<point|-6|0.75>|<point|-6.0|2.25>>|<line|<point|-7.75|6>|<point|-7.75|5.25>>|<line|<point|-7.25|6>|<point|-7.25|5.25>>|<line|<point|-6.75|6>|<point|-6.75|5.25>>|<line|<point|-6.25|6>|<point|-6.25|5.25>>|<line|<point|-5.75|6>|<point|-5.75|5.25>>|<line|<point|-5.25|6>|<point|-5.25|5.25>>|<line|<point|-4.75|6>|<point|-4.75|5.25>>|<line|<point|-4.25|6>|<point|-4.25|5.25>>|<line|<point|-3.75|6>|<point|-3.75|5.25>>|<line|<point|-6|5.25>|<point|-6.0|3.75251743617093>>|<line|<point|-4|5.25>|<point|-4.0|3.75503487234186>>|<line|<point|-2|5.25>|<point|-2.0|3.75755230851279>>|<line|<point|-3.25|6>|<point|-3.25|5.25>>|<line|<point|-2.75|6>|<point|-2.75|5.25>>|<line|<point|-2.25|6>|<point|-2.25|5.25>>|<line|<point|-1.75|6>|<point|-1.75|5.25>>|<line|<point|-1.25|6>|<point|-1.25|5.25>>|<line|<point|-0.75|6>|<point|-0.75|5.25>>|<line|<point|-0.25|6>|<point|-0.25|5.25>>|<line|<point|0.25|6>|<point|0.25|5.25>>|<line|<point|0|5.25>|<point|3.84987216161167e-15|3.76006974468371>>|<line|<point|2|5.25>|<point|2.0|3.76258718085464>>|<line|<point|0.75|6>|<point|0.75|5.25>>|<line|<point|1.25|6>|<point|1.25|5.25>>|<line|<point|1.75|6>|<point|1.75|5.25>>|<line|<point|2.25|6>|<point|2.25|5.25>>|<line|<point|2.75|6>|<point|2.75|5.25>>|<line|<point|3.25|6>|<point|3.25|5.25>>|<line|<point|3.75|6>|<point|3.75|5.25>>|<line|<point|4|5.25>|<point|4.0|3.75>>|<cline|<point|-8.0|5.25>|<point|8.0|5.25>|<point|8.0|3.75>|<point|-8.0|3.75>>|<line|<point|6|5.25>|<point|6.0|3.75>>|<line|<point|4.25|6>|<point|4.25|5.25>>|<line|<point|4.75|6>|<point|4.75|5.25>>|<line|<point|5.25|6>|<point|5.25|5.25>>|<line|<point|5.75|6>|<point|5.75|5.25>>|<line|<point|6.25|6>|<point|6.25|5.25>>|<line|<point|6.75|6>|<point|6.75|5.25>>|<line|<point|7.25|6>|<point|7.25|5.25>>|<line|<point|7.75|6>|<point|7.75|5.25>>|<with|fill-color|pastel
    blue|<cline|<point|-8.0|3.25>|<point|-8.0|2.75>|<point|8.0|2.75>|<point|8.0|3.25>>>|<with|color|dark
    blue|arrow-end|\<gtr\>|line-width|2ln|<spline|<point|0.25|3.25>|<point|-0.25|3.25>|<point|-0.5|3.0>|<point|-0.25|2.75>|<point|0.25|2.75>|<point|0.5|3.0>>>|<with|color|dark
    blue|arrow-end|\<gtr\>|line-width|2ln|<spline|<point|0.25|0.25>|<point|-0.25|0.25>|<point|-0.5|0.0>|<point|-0.25|-0.25>|<point|0.25|-0.25>|<point|0.5|0.0>>>|<spline|<point|-7.75|6.25>|<point|0.0|6.5>|<point|7.75|6.25>>|<spline|<point|-6.25|6.25>|<point|-7.0|6.5>|<point|-7.75|6.25>>|<with|text-at-valign|center|text-at-halign|center|<math-at|N|<point|0|7>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|R\<approx\>lg
    N|<point|-7|7>>>|<spline|<point|-8.25|5.25>|<point|-8.5|4.5>|<point|-8.25|3.75>>|<with|text-at-valign|center|text-at-halign|right|<math-at|lg
    lg N|<point|-8.73557097370726|3.97126013264554>>>|<with|text-at-valign|center|text-at-halign|right|<math-at|lg
    R\<approx\>|<point|-8.66705134800684|4.65645638964975>>>|<with|text-at-valign|center|text-at-halign|right|<math-at|lg
    N|<point|-8.75|1.5>>>|<spline|<point|-8.25|5.25>|<point|-8.55033995634099|1.49999304792759>|<point|-8.25|-2.25>>>>

    \;

    <pastel|Slightly cheating in picture: we should have used 16 butterflies
    on every line>
  </hidden>|<\hidden>
    <tit|Fast integer multiplication>

    <unroll|<\shown>
      <strong|Frer's algorithm>

      Coefficients in <math|\<cal-R\>=\<bbb-C\><rsub|b><around*|[|X|]>/<around|(|X<rsup|R/2>+1|)>>

      Existence of a ``principal'' <math|N>-th root of unity
      <math|\<omega\>>, with <math|\<omega\><rsup|2*N/R>=X>

      <with|color|dark green|Fast giant butterflies (size <math|R\<times\>lg
      R>)>, <with|color|dark red|but slow <em|twiddling>
      <math|\<rightsquigarrow\>> multiplications in <math|\<cal-R\>>>

      <\eqnarray*>
        <tformat|<cwith|3|3|3|3|cell-tsep|0.5spc>|<table|<row|<cell|<math-ss|I><around*|(|n|)>>|<cell|=>|<cell|<with|color|dark
        green|O<around*|(|<around*|(|<frac|N|R>*<frac|lg N|lg
        R>|)>\<cdot\><around*|(|b*R*lg R|)>|)>>+<with|color|dark
        red|O<around*|(|<around*|(|<frac|N|R>*<frac|lg N|lg
        R>|)>\<cdot\><math-ss|M><rsub|\<bbb-C\><rsub|b>><around*|(|R|)>|)>>>>|<row|<cell|<frac|<math-ss|I><around*|(|n|)>|n*lg
        n>>|<cell|=>|<cell|<with|color|dark
        green|O<around*|(|1|)>>+<with|color|dark
        red|O<around*|(|<frac|<math-ss|I><around*|(|R*b|)>|<around*|(|R*b|)>*lg
        <around*|(|R*b|)>>|)>><space|2em><around*|(|R\<approx\>b\<approx\>lg
        n|)>>>|<row|<cell|<math-ss|I><around*|(|n|)>>|<cell|=>|<cell|n*lg
        n*2<rsup|O<around*|(|log<rsup|\<ast\>> n|)>>>>>>
      </eqnarray*>
    </shown>|<\hidden*>
      <strong|New algorithm>

      Ordinary DFT, but accelerate the giant butterflies:

      <htab|5mm><manila-paper|DFT of size <math|R\<times\>lg R> over
      <math|\<bbb-C\><rsub|b>> <math|<above|\<rightsquigarrow\>|Bluestein>>
      <math|O<around*|(|<math-ss|M><rsub|\<bbb-C\><rsub|b><around*|[|X|]>><around*|(|R|)>|)>>
      <math|<above|\<rightsquigarrow\>|Kronecker>>
      <math|O<around*|(|<math-ss|I><around*|(|R*b|)>|)>>><htab|5mm>

      <with|color|dark red|Slower giant butterflies>, <with|color|dark
      green|but faster <em|twiddling>>

      Ordinary DFT <math|\<Rightarrow\>> faster point-wise multiplication
      (application<nbsp>: integer matrices)
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Cyclic convolutions <math|\<sim\>> DFTs>

    <unroll|<\shown>
      <strong|Cyclic convolution <math|\<rightsquigarrow\>> DFT>

      <math|P,Q\<in\>\<bbb-K\><around*|[|X|]>/<around*|(|X<rsup|n>-1|)>>,
      <math|n\<in\>2<rsup|\<bbb-N\><rsup|\<gtr\>>>>, primitive <math|n>-th
      root of unity <math|\<omega\>>

      <\eqnarray*>
        <tformat|<table|<row|<cell|<around*|(|<around*|(|P*Q|)><rsub|0>,\<ldots\>,<around*|(|P*Q|)><rsub|n-1>|)>>|<cell|=>|<cell|DFT<rsub|\<omega\>><rsup|-1><around*|(|DFT<rsub|\<omega\>><around*|(|P<rsub|0>,\<ldots\>,P<rsub|n-1>|)>*DFT<rsub|\<omega\>><around*|(|Q<rsub|0>,\<ldots\>,Q<rsub|n-1>|)>|)>>>>>
      </eqnarray*>
    </shown>|<\hidden*>
      <vspace*|1fn><strong|DFT <math|\<rightsquigarrow\>> Cyclic convolution>
      [Bluestein 70]

      Assume <math|\<eta\>\<in\>\<bbb-K\>> given with
      <math|\<eta\><rsup|2>=\<omega\>>.

      <\equation*>
        <tabular*|<tformat|<cwith|1|1|1|1|cell-bsep|1spc>|<cwith|2|2|1|1|cell-tsep|1spc>|<table|<row|<cell|f<rsub|i>\<assign\>\<eta\><rsup|i<rsup|2>>,<space|2em>g<rsub|i>\<assign\>\<eta\><rsup|-i<rsup|2>>>>|<row|<cell|f<rsub|i+n>=\<eta\><rsup|<around*|(|i+n|)><rsup|2>>=\<eta\><rsup|i<rsup|2>+n<rsup|2>+2*n*i>=\<eta\><rsup|i<rsup|2>>*\<omega\><rsup|<around*|(|<frac|n|2>+i|)>*n>=f<rsub|i>,<space|2em>g<rsub|i+n>=g<rsub|i>>>>>>
      </equation*>

      Then <math|\<omega\><rsup|i*j>=f<rsub|i>*f<rsub|j>*g<rsub|i-j>>, so for
      all <math|a\<in\>\<bbb-K\><rsup|n>><nbsp>:

      <\equation*>
        <wide|a|^><rsub|i>=DFT<rsub|\<omega\>><around*|(|a|)><rsub|i>=<big|sum><rsub|j=0><rsup|n-1>a<rsub|j>*\<omega\><rsup|i*j>=f<rsub|i>*<big|sum><rsub|j=0><rsup|n-1><around*|(|a<rsub|j>*f<rsub|j>|)>*g<rsub|i-j>
      </equation*>

      One recognizes a cyclic convolution
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Complexity analysis>

    <unroll|<\shown>
      <strong|Logarithmically slow function>

      <\compact>
        Function <math|\<Phi\>:<around*|[|x<rsub|0>,\<infty\>|)>\<rightarrow\>\<bbb-R\>>
        such that there exists a <math|\<ell\>\<in\>\<bbb-N\>> with

        <\eqnarray*>
          <tformat|<table|<row|<cell|<around*|(|log<rsup|\<circ\>\<ell\>>\<circ\>\<Phi\>\<circ\>exp<rsup|\<circ\>\<ell\>>|)><around*|(|x|)>>|<cell|=>|<cell|log
          x+O<around*|(|1|)><label|log-slow-cond><space|4em><around*|(|x\<rightarrow\>\<infty\>|)>.>>>>
        </eqnarray*>

        Examples: <math|\<Phi\><around*|(|x|)>=log x>,
        <math|\<Phi\><around*|(|x|)>=log<rsup|2> x>,
        <math|\<Phi\><around*|(|x|)>=<around*|(|log x|)><rsup|log log x>>,
        <math|\<Phi\><around*|(|x|)>=\<mathe\><rsup|\<mathe\><rsup|2014*log
        log log x>>><vspace|1fn>
      </compact>
    </shown>|<\hidden*>
      <\compact>
        <strong|Iterateurs> [see also calle 92, Schmeling 01]

        <\eqnarray*>
          <tformat|<table|<row|<cell|\<Phi\><rsup|\<ast\>><around*|(|\<Phi\><around*|(|x|)>|)>>|<cell|=>|<cell|\<Phi\><around*|(|x|)>-1>>|<row|<cell|\<Phi\><rsup|\<ast\>><around*|(|x|)>>|<cell|=>|<cell|min
          <around*|{|k\<in\>\<bbb-N\>:\<Phi\><rsup|\<circ\>k><around*|(|x|)>\<leqslant\>\<sigma\>|}>.>>>>
        </eqnarray*>
      </compact>
    </hidden*>|<\hidden*>
      <\compact>
        <\lemma*>
          <math|\<Phi\>> logarithmically slow, <math|\<Phi\><rsup|\<ast\>>>
          iterator of <math|\<Phi\>>. Then

          <\eqnarray*>
            <tformat|<table|<row|<cell|\<Phi\><rsup|\<ast\>><around*|(|x|)>>|<cell|=>|<cell|log<rsup|\<ast\>>
            x+O<around*|(|1|)>>>>>
          </eqnarray*>
        </lemma*>
      </compact>
    </hidden*>|<\hidden*>
      <\compact>
        <switch|<\shown>
          <\lemma*>
            <math|\<Phi\>> logarithmically slow. Constants
            <math|K,B,L,\<ell\>> and function <math|T> such that

            <\eqnarray*>
              <tformat|<table|<row|<cell|T<around*|(|x|)>>|<cell|\<leqslant\>>|<cell|K*<around*|(|1+<frac|B|log<rsup|\<circ\>\<ell\>>
              x>|)>*T<around*|(|\<Phi\><around*|(|x|)>|)>+L.>>>>
            </eqnarray*>

            Then <math|T<around*|(|x|)>=O<around*|(|K<rsup|log<rsup|\<ast\>>
            n>|)>>.
          </lemma*>
        </shown>|<\hidden>
          <\lemma*>
            <math|\<Phi\><rsub|1>,\<ldots\>,\<Phi\><rsub|k>> logarithmically
            slow. Constants <math|K,B,L,\<ell\>>,
            <math|c<rsub|1>+\<cdots\>+c<rsub|k>=1> and function<nbsp><math|T>
            such that

            <\eqnarray*>
              <tformat|<table|<row|<cell|T<around*|(|x|)>>|<cell|\<leqslant\>>|<cell|K*<around*|(|1+<frac|B|log<rsup|\<circ\>\<ell\>>
              x>|)>*<around*|(|c<rsub|1>*T<around*|(|\<Phi\><rsub|1><around*|(|x|)>|)>+\<cdots\>+c<rsub|k>*T<around*|(|\<Phi\><rsub|k><around*|(|x|)>|)>|)>+L.>>>>
            </eqnarray*>

            Then <math|T<around*|(|x|)>=O<around*|(|K<rsup|log<rsup|\<ast\>>
            n>|)>>.
          </lemma*>
        </hidden>>
      </compact>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Which approach yields the fastest algorithm?>

    <unroll|<\shown>
      <\compact>
        We now have several ways to show that

        <\eqnarray*>
          <tformat|<table|<row|<cell|<math-ss|I><around*|(|n|)>>|<cell|=>|<cell|O<around*|(|n*lg
          n*K<rsup|log<rsup|\<ast\>> n>|)>.>>>>
        </eqnarray*>

        What is the best <math|K> we can get?<vspace|2fn>
      </compact>
    </shown>|<\hidden*>
      <\compact>
        <strong|Frer>, after optimisation : <math|K=16> (?)

        <strong|We>, after optimisation : <math|K=8><vspace|2fn>
      </compact>
    </hidden*>|<\hidden*>
      <strong|Ingredients>

      <\itemize>
        <unroll|<\shown>
          <item>Multiplication in <math|\<bbb-Z\>> <math|\<rightsquigarrow\>>
          multiplication in <math|<around*|(|\<bbb-Z\>/<around*|\<nobracket\>|<around*|(|2<rsup|n>-1|)>*\<bbb-Z\>|\<nobracket\>>|)><around*|[|\<mathi\>|]>>.
        </shown>|<\hidden*>
          <item>One argument shared many times in recursive calls
          <math|\<rightsquigarrow\>> 2 DFTs instead of 3.
        </hidden*>|<\hidden*>
          <item>Convolution of length <math|N> with <math|b>-bit coefficients
          <math|\<rightsquigarrow\>> output of size <math|2*b+O<around*|(|lg
          N|)>>.

          Taking <math|b\<asymp\><around*|(|lg n|)><rsup|2>> instead of
          <math|b\<asymp\>lg n> improves the ratio
          <math|<around*|(|2*b+O<around*|(|lg N|)>|)>/b>.
        </hidden*>|<\hidden*>
          <item>Increase <math|R\<approx\>lg N>
          <math|<with|color|black|\<rightsquigarrow\>>>
          <math|R\<approx\><around*|(|lg N|)><rsup|lg lg
          N+O<around*|(|1|)>>>.

          Cost Bluestein--Kronecker <math|\<gg\>> cost twiddling and other.
        </hidden*>>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Can we do even better?>

    <unroll|<\shown>
      <strong|Where does the cost come from?>

      <\compact>
        <\enumerate-alpha>
          <item>Factor <math|2> <math|<with|color|blue|\<leftsquigarrow\>>>
          Kronecker segmentation (<math|\<bbb-Z\><around*|[|\<mathi\>|]>\<rightsquigarrow\>\<bbb-C\><rsub|b><around*|[|X|]>>,
          cutting into pieces of <math|<frac|b|2>> bits)

          <item>Factor <math|2> <math|<with|color|blue|\<leftsquigarrow\>>>
          direct and inverse DFT

          <item>Factor <math|2> <math|<with|color|blue|\<leftsquigarrow\>>>
          Kronecker substitution (<math|\<bbb-C\><rsub|b><around*|[|X|]>/<around*|(|X<rsup|R>-1|)>\<rightsquigarrow\>\<bbb-Z\>/<around*|\<nobracket\>|<around*|(|2<rsup|2*b*R>-1|)>*\<bbb-Z\>|\<nobracket\>>>)
        </enumerate-alpha>
      </compact>
    </shown>|<\hidden*>
      <strong|Fermat primes>

      <\compact>
        And <em|if, <greyed|if>, <with|color|grey|if>> there were
        sufficiently many prime numbers of the form
        <math|p=2<rsup|2<rsup|k>>+1>

        (Optimized) Frer approach for <math|\<bbb-K\>=\<bbb-F\><rsub|p>>
        yields <math|K=4>

        Unfortunately..., <math|p=2<rsup|16>+1> is the largest known prime
        number of this form
      </compact>
    </hidden*>|<\hidden*>
      <strong|Mersenne primes>

      <\compact>
        <\conjecture>
          <label|mersenne-conj>Let <math|\<pi\><rsub|m><around*|(|x|)>=<around*|{|p\<leqslant\>x:p=2<rsup|q>-1,p<text|
          prime>,q<text| prime>|}>>. Then <math|\<exists\>a\<less\>b>,

          <\equation*>
            a*log log x\<less\>\<pi\><rsub|m><around*|(|x|)>\<less\>b*log log
            x
          </equation*>
        </conjecture>
      </compact>
    </hidden*>|<\hidden*>
      <strong|Crandall--Fagin algorithm>

      <\compact>
        Multiplication <math|\<bbb-F\><rsub|p><around*|[|\<mathi\>|]><around*|[|X|]>/<around*|(|X<rsup|M>-1|)>>
        <math|<with|color|black|\<rightsquigarrow\>>>
        <math|\<bbb-F\><rsub|p<rprime|'>><around*|[|\<mathi\>|]><around*|[|X,Y|]>/<rigid|<around*|(|X<rsup|M>-1,Y<rsup|N>-1|)>>>,
        <math|p<rprime|'>\<lll\>p>

        Conjecture<nbsp><reference|mersenne-conj> <math|\<Rightarrow\>>
        <math|K=4>
      </compact>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Multiplication in <math|\<bbb-F\><rsub|q><around*|[|X|]>> and in
    <math|\<bbb-K\><around*|[|X|]>>>

    <unroll|<\shown>
      Kronecker<nbsp>: <math|<math-ss|M><rsub|\<bbb-F\><rsub|p>><around*|(|n|)>=O<around*|(|<math-ss|I><around*|(|n*log
      p|)>|)>> if <math|log n=O<around*|(|log p|)>>
    </shown>|<\hidden*>
      Schnhage--Strassen<nbsp>: <math|<math-ss|M><rsub|\<bbb-F\><rsub|q>><around*|(|n|)>=O<around*|(|n*log
      n*log log n*<math-ss|M><rsub|\<bbb-F\><rsub|q>><around*|(|1|)>|)>> if
      <math|char \<bbb-F\><rsub|q>\<gtr\>2>
    </hidden*>|<\hidden*>
      Schnhage<nbsp>: <math|<math-ss|M><rsub|\<bbb-F\><rsub|q>><around*|(|n|)>=O<around*|(|n*log
      n*log log n*<math-ss|M><rsub|\<bbb-F\><rsub|q>><around*|(|1|)>|)>> for
      all <math|q>
    </hidden*>|<\hidden*>
      Cantor--Kaltofen<nbsp>: for any <math|\<bbb-K\>>-algebra
      <math|\<bbb-A\>>, <math|<math-ss|M><rsub|\<bbb-A\>><rsup|alg><around*|(|n|)>=O<around*|(|n*log
      n*log log n|)>>
    </hidden*>|<\hidden*>
      Kronecker<nbsp>: <math|<math-ss|M><rsub|\<bbb-F\><rsub|p<rsup|k>>><around*|(|n|)>\<asymp\><math-ss|M><rsub|\<bbb-F\><rsub|p>><around*|(|k*n|)>>,
      modulo <math|O<around*|(|k*n*log p|)>> operations
    </hidden*>|<\hidden*>
      \;

      <\compact>
        <\theorem*>
          We have, <strong|uniformly> in <math|p>:

          <\eqnarray*>
            <tformat|<table|<row|<cell|<math-ss|M><rsub|p><around*|(|n|)>>|<cell|=>|<cell|O<around*|(|<around*|(|n*log
            p|)>*log<around*|(|n*log p|)>*8<rsup|log<rsup|\<ast\>><around*|(|n*log
            p|)>>|)>>>>>
          </eqnarray*>
        </theorem*>
      </compact>
    </hidden*>|<\hidden*>
      <\compact>
        <\theorem*>
          Modulo ``plausable conjectures'', we have, <strong|uniformly> in
          <math|p>:

          <\eqnarray*>
            <tformat|<table|<row|<cell|<math-ss|M><rsub|p><around*|(|n|)>>|<cell|=>|<cell|O<around*|(|<around*|(|n*log
            p|)>*log<around*|(|n*log p|)>*4<rsup|log<rsup|\<ast\>><around*|(|n*log
            p|)>>|)>>>>>
          </eqnarray*>
        </theorem*>
      </compact>
    </hidden*>|<\hidden*>
      <\compact>
        <\theorem*>
          Let <math|\<bbb-A\>> be an <math|\<bbb-F\><rsub|p>>-algebra. Then
          <math|<math-ss|M><rsup|alg><rsub|\<bbb-A\>><around*|(|n|)>=O<around*|(|n*lg
          n*8<rsup|log<rsup|\<ast\>> n>|)>>, uniformly in <math|\<bbb-A\>>.
          Moreover, we only need <math|O<around*|(|n*4<rsup|log<rsup|\<ast\>>
          n>|)>> (non scalar) multiplications in <math|\<bbb-A\>>.
        </theorem*>
      </compact>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Proof elements>

    <\enumerate>
      <unroll|<\shown>
        <item>Multiplication in <math|\<bbb-F\><rsub|p><around*|[|X|]>>
        <math|\<rightsquigarrow\>> multiplication in
        <math|\<bbb-F\><rsub|p<rsup|k>><around*|[|X|]>>
      </shown>|<\hidden*>
        <item><math|k> such that <math|\<bbb-F\><rsub|p<rsup|k>><around*|[|X|]>>
        admits an <math|N>-th primitive root of unity <math|\<omega\>>, with
        <math|N> large and smooth
      </hidden*>|<\hidden*>
        <item>Write <math|N=N<rsub|1>*\<cdots\>*N<rsub|r>> with'
        <math|N<rsub|1>,\<ldots\>,N<rsub|r>> ``under control'' and use
        Bluestein-Kronecker
      </hidden*>|<\hidden*>
        <\fold-back>
          <\session|pari|default>
            <\folded-io|Pari] >
              factor (2^60 - 1)
            <|folded-io>
              <with|color|magenta|%1 = <math|<with|color|blue|<matrix|<tformat|<table|<row|<cell|3>|<cell|2>>|<row|<cell|5>|<cell|2>>|<row|<cell|7>|<cell|1>>|<row|<cell|11>|<cell|1>>|<row|<cell|13>|<cell|1>>|<row|<cell|31>|<cell|1>>|<row|<cell|41>|<cell|1>>|<row|<cell|61>|<cell|1>>|<row|<cell|151>|<cell|1>>|<row|<cell|331>|<cell|1>>|<row|<cell|1321>|<cell|1>>>>>>>>
            </folded-io>

            <\folded-io|Pari] >
              factor (7^60 - 1)
            <|folded-io>
              <with|color|magenta|%2 = <math|<with|color|blue|<matrix|<tformat|<table|<row|<cell|2>|<cell|5>>|<row|<cell|3>|<cell|2>>|<row|<cell|5>|<cell|3>>|<row|<cell|11>|<cell|1>>|<row|<cell|13>|<cell|1>>|<row|<cell|19>|<cell|1>>|<row|<cell|31>|<cell|1>>|<row|<cell|43>|<cell|1>>|<row|<cell|61>|<cell|1>>|<row|<cell|181>|<cell|1>>|<row|<cell|191>|<cell|1>>|<row|<cell|281>|<cell|1>>|<row|<cell|2801>|<cell|1>>|<row|<cell|4021>|<cell|1>>|<row|<cell|159871>|<cell|1>>|<row|<cell|6568801>|<cell|1>>|<row|<cell|555915824341>|<cell|1>>>>>>>>
            </folded-io>

            <\folded-io|Pari] >
              factor (2^210 - 1)
            <|folded-io>
              <with|color|magenta|%3 = <math|<with|color|blue|<matrix|<tformat|<table|<row|<cell|3>|<cell|2>>|<row|<cell|7>|<cell|2>>|<row|<cell|11>|<cell|1>>|<row|<cell|31>|<cell|1>>|<row|<cell|43>|<cell|1>>|<row|<cell|71>|<cell|1>>|<row|<cell|127>|<cell|1>>|<row|<cell|151>|<cell|1>>|<row|<cell|211>|<cell|1>>|<row|<cell|281>|<cell|1>>|<row|<cell|331>|<cell|1>>|<row|<cell|337>|<cell|1>>|<row|<cell|5419>|<cell|1>>|<row|<cell|29191>|<cell|1>>|<row|<cell|86171>|<cell|1>>|<row|<cell|106681>|<cell|1>>|<row|<cell|122921>|<cell|1>>|<row|<cell|152041>|<cell|1>>|<row|<cell|664441>|<cell|1>>|<row|<cell|1564921>|<cell|1>>>>>>>>
            </folded-io>

            <\folded-io|Pari] >
              factor (37^60 - 1)
            <|folded-io>
              <with|color|magenta|%4 = <math|<with|color|blue|<matrix|<tformat|<table|<row|<cell|2>|<cell|4>>|<row|<cell|3>|<cell|3>>|<row|<cell|5>|<cell|2>>|<row|<cell|7>|<cell|1>>|<row|<cell|11>|<cell|1>>|<row|<cell|13>|<cell|1>>|<row|<cell|19>|<cell|1>>|<row|<cell|31>|<cell|1>>|<row|<cell|41>|<cell|1>>|<row|<cell|43>|<cell|1>>|<row|<cell|61>|<cell|1>>|<row|<cell|67>|<cell|1>>|<row|<cell|137>|<cell|1>>|<row|<cell|601>|<cell|1>>|<row|<cell|2671>|<cell|1>>|<row|<cell|4021>|<cell|1>>|<row|<cell|4271>|<cell|1>>|<row|<cell|144061>|<cell|1>>|<row|<cell|318211>|<cell|1>>|<row|<cell|1824841>|<cell|1>>|<row|<cell|239020081>|<cell|1>>|<row|<cell|6002229721>|<cell|1>>|<row|<cell|11507920001>|<cell|1>>|<row|<cell|51654756031569841>|<cell|1>>>>>>>>
            </folded-io>

            <\input|Pari] >
              \;
            </input>
          </session>
        </fold-back>
      </hidden*>>
    </enumerate>
  </hidden>>
</body>

<initial|<\collection>
</collection>>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|chirp-formula|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|it-log|<tuple|<with|mode|<quote|math>|\<bullet\>>|4>>
    <associate|log-slow-cond|<tuple|<with|mode|<quote|math>|\<bullet\>>|19>>
    <associate|mersenne-conj|<tuple|1|21>>
    <associate|wrap-fig|<tuple|?|?>>
  </collection>
</references>